/***************************************************************************
                          display_results2.c  -  description
                             -------------------
    begin                : Sun Apr 28 2002
    copyright            : (C) 2002 by Spencer Hardy
    email                : diceman@dircon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "relay.h"

void strip_chars(char *string) {

	char *p=string;;
	
	if(p==NULL) {
		return;
	}
	
	while(*p++) {
		if(*p=='\n' || *p == ',' || *p == '\r') {
			*p = ' ';
		}
	}
}

int usage(char *pname) {

	printf("\n\nUsage: %s -c [config file] -s [iprange] -w [path to html file] -p [number of threads] -b [email address to relay to] -e [path to mail file] -m [time to wait for mail]\n", pname);
	printf("\nOptions:\n\n");
	printf("-p [number of threads]\n");
	printf("\t	Forks the specified number of threads\n");
	printf("\t	Set this to whatever works best for the machine\n");
	printf("\t	FreeBSD seems fine with 400+ The Linux test\n");
	printf("\t	machine won't take anymore that 250\n");
	printf("\n-b [email address]\n");
	printf("\t	When this option is supplied, SmtpRC will send email\n");
	printf("\t	through any servers that fail any tests. It must\n");
	printf("\t	also correspond with the configuration file. see the\n");
	printf("\t	README file for more info.\n");
	printf("\n-e [path to mail file]\n");
	printf("\t	When this opton is used SmtpRC will check the mail file\n");
	printf("\t	specified for relayed emails and print the results to the\n");
	printf("\t	mail file\n");
	printf("\n-w [filename]\n");
	printf("\t	Prints detailed HTML output of all failed\n");
	printf("\t	checks to the filename specified. If used with the -a\n");
	printf("\t	option it will print all checks not just those that\n");
	printf("\t	failed\n");
	printf("\n-f [filename]\n");
	printf("\t	Same as the -w option except that output is txt\n");
	printf("\t	rather than html\n");
	printf("\n-o [filename]\n");
	printf("\t	Output results in machine readable format (comma\n");
	printf("\t	seperated values)\n");
	printf("\n-c [config file]\n");
	printf("\t	Read the checks from the specified filename.\n");
	printf("\n-y [email template file]\n");
	printf("\t	Specify an email template to use.\n");
	printf("\n-s [ip address range]\n");
	printf("\t	You can use this option to specify\n");
	printf("\t	the ip address range (or single host) to scan for\n");
	printf("\t	open relay's. Must be in the format 127.0.*.1-200\n");
	printf("\n-i [ip list file]\n");
	printf("\t	Use this option to specify a list of ip addresses or\n");
	printf("\t	hostnames\n");
	printf("\n-k [config file to generate]\n");
	printf("\t	Use this option to generate a config file with the options\n");
	printf("\t	used on the command line\n");
	printf("\n-j [auto config file]\n");
	printf("\t	use this option to use an automatic SmtpRC config file\n");
	printf("\n-r [timeout]\n");
	printf("\t	Specify a timeout value used for reading\n");
	printf("\t	data from hosts. The default is 60 seconds but you\n");
	printf("\t	may have to increase it up to 90+.\n");
	printf("\n-m [time to wait]\n");
	printf("\t	Use this option to specify the time to wait before checking\n");
	printf("\t	the mail file\n");
	printf("\n-l [timeout]\n");
	printf("\t	Specify a timeout value used for connecting\n");
	printf("\t	to hosts. The default is 15 seconds but you may\n");
	printf("\t	need to increase it with slow networks\n");
	printf("\n-n\t	Using this option will convert all IP addresses to\n");
	printf("\t	domiain names\n");
	printf("\n-a\t	This option will print all of the check to the file\n");
	printf("\t	specified not just the tests that fail. the failed tests\n");
	printf("\t	will be highlighted in red\n");
	printf("\n-v\t	Verbose mode. This is not a rcommended option. It\n");
	printf("\t	displays more output about what's going on.\n");
	printf("		displays more output\n");
	printf("\n-z\t	Verbose html mode. This option display more verbose\n");
  printf("\t	html output. It will display the full smtp transaction with\n");
  printf("		the host it is testing\n\n\n");
	fflush(stdout);
	exit(0);

}

int banner(void) {

 	printf("\n\n\n\n\t----------------------------\n");	
	printf("\t|    SMTP Relay Checker    |\n");
	printf("\t|      Spencer Hardy       |\n");
	printf("\t|   diceman@dircon.co.uk   |\n");
	printf("\t| www.diceman.dircon.co.uk |\n");
	printf("\t|          0.9.7b          |\n");
	printf("\t----------------------------\n\n\n\n");
	fflush(stdout);
  return(0);
}

int open_file(char *filename) {

	FILE *fd;

	if((fd = fopen(filename, "w")) == NULL) {
		fprintf(stderr, "\nUnable to open %s for writing\n", filename);
		exit(1);
	}

	fclose(fd);


	return(0);

}


int print_txt_results(void) {

	int x = 0;
	int y = 0;
	int secs = 0;
	int mins = 0;
	time_t end_time;

	if((o.txt_fd = fopen(o.txt_file, "w")) == NULL) {
  	fprintf(stderr, "\nUnable to open %s for writing\n", o.txt_file);
    exit(1);
  }

	fprintf(o.txt_fd, "\n\t\t\t<!-- SMTP Relay Check  release 0.9.6 Beta --!>\n\n");
  fprintf(o.txt_fd, "\t\t<!-- An SMTP Relay checker for the unix operating system --!>\n");
  fprintf(o.txt_fd, "\t\t\t\t<!-- by Spencer Hardy --!>\n\n");
  fprintf(o.txt_fd, "\t\t\t<!-- http://www.diceman.dircon.co.uk --!>\n\n\n\n");

  fflush(o.txt_fd);

	for(x=0;x<o.no_hostnames;x++) {
  	if(!o.track[x][o.no_rules+3] && !o.track[x][o.no_rules+2]) {
    	for(y=0;y<o.no_rules;y++) {
      	if(o.track[x][y] == 4||o.display) {
					if(o.track[x][y] == 4) {
						if(f.get_hostname) {
							fprintf(o.txt_fd, "Results for %s Rule %d **FAILED**\n", get_hostname(hn.hostname[x]), y);
						}
						else {
							fprintf(o.txt_fd, "Results for %s Rule %d **FAILED**\n", hn.hostname[x], y);
						}
            fprintf(o.txt_fd, "Results for %s Rule %d **FAILED**\n", hn.hostname[x], y);
            fprintf(o.txt_fd, "\tBANNER = %s\n", reply.banner[x][0]);
            fprintf(o.txt_fd, "\tHELO = %s\n", reply.helo[x][0]);
            fprintf(o.txt_fd, "\tMAIL FROM = %s\n", reply.mail_from[x][y]);
            fprintf(o.txt_fd, "\tRCPT TO = %s\n\n", reply.rcpt_to[x][y]);
					}
					else if(o.track[x][y] == 3) {
          	if(f.get_hostname) {
            	fprintf(o.txt_fd, "Results for %s Rule %d **FAILED INITIAL TEST BUT DID NOT RELAY MAIL**\n", get_hostname(hn.hostname[x]), y);
            }
            else {
            	fprintf(o.txt_fd, "Results for %s Rule %d **PASSED**\n", hn.hostname[x], y);
            }
            fprintf(o.txt_fd, "\tBANNER = %s\n", reply.banner[x][0]);
            fprintf(o.txt_fd, "\tHELO = %s\n", reply.helo[x][0]);
            fprintf(o.txt_fd, "\tMAIL FROM = %s\n", reply.mail_from[x][y]);
            fprintf(o.txt_fd, "\tRCPT TO = %s\n\n", reply.rcpt_to[x][y]);
          }
					else {
						if(f.get_hostname) {
							fprintf(o.txt_fd, "Results for %s Rule %d **PASSED**\n", get_hostname(hn.hostname[x]), y);
						}
						else {
							fprintf(o.txt_fd, "Results for %s Rule %d **PASSED**\n", hn.hostname[x], y);
						}
            fprintf(o.txt_fd, "\tBANNER = %s\n", reply.banner[x][0]);
            fprintf(o.txt_fd, "\tHELO = %s\n", reply.helo[x][0]);
            fprintf(o.txt_fd, "\tMAIL FROM = %s\n", reply.mail_from[x][y]);
            fprintf(o.txt_fd, "\tRCPT TO = %s\n\n", reply.rcpt_to[x][y]);
          }
				}
			}
		}
	}
	end_time = get_time();
  secs = (int)end_time-o.start_time;
  if(secs>60) {
  	mins = 0;
    while(secs>60) {
    	mins++;
      secs-=60;
    }
  }
  if(mins != -1 && mins != 0) {
  	fprintf(o.txt_fd, "Scanned %d hosts in %d mins and %d seconds<br />Spencer Hardy - diceman@dircon.co.uk", (int)o.no_hostnames, mins, secs);
  }
  else {
  	fprintf(o.txt_fd, "Scanned %d hosts in %d seconds<br />Specer Hardy - diceman@dircon.co.uk", (int)o.no_hostnames, secs);
  }
	fclose(o.txt_fd);

	return(0);
}

int print_m_results(void) {


	int x;
	int y;

	FILE *fd;

	if((fd=fopen(o.machine_file, "w"))==NULL) {
		fprintf(stderr, "\n\nERROR\n\nUnable to open file specified with -o for writing\n\n");
		exit(1);
	}


	for(x=0;x<o.no_hostnames;x++) {
		for(y=0;y<o.no_rules;y++) {
			if(o.display) {
				if(o.track[x][o.no_rules+1] == 1) {
					fprintf(fd, "%s,%s,%d,READ TIMED OUT,,,,,\n", hn.hostname[x], hn.rhostname[x], y);
					y=o.no_rules;
				}
				else if(o.track[x][o.no_rules+1] == 2) {
					fprintf(fd, "%s,%s,%d,WRITE TIMED OUT,,,,,\n", hn.hostname[x], hn.rhostname[x], y);
					y=o.no_rules;
				}
				else if(o.track[x][o.no_rules+1] == 3) {
					fprintf(fd, "%s,%s,%d,REMOTE END CLOSED CONNECTION,,,,,\n", hn.hostname[x], hn.rhostname[x], y);
					y=o.no_rules;
				}
				else if(o.track[x][o.no_rules+1] == 4) {
                                        fprintf(fd, "%s,%s,%d,COULD NOT RESOLVE DOMAIN OR INVALID IP ADDRESS,,,,,\n", hn.hostname[x], hn.rhostname[x], y);
					y=o.no_rules;
                                }
				else if(o.track[x][y] == 0) {
					fprintf(fd, "%s,%s,%d,UNABLE TO ESTABLISH CONECTION,,,,,\n", hn.hostname[x], hn.rhostname[x], y);
					y=o.no_rules;
				}
				else if(o.track[x][y] == 1) {
					//strip_chars(reply.banner[x][0]);
					//strip_chars(reply.helo[x][0]);
					//strip_chars(reply.mail_from[x][y]);
					//strip_chars(reply.rcpt_to[x][y]);
					fprintf(fd, "%s,%s,%d,PASSED,%s,%s,%s,%s\n", hn.hostname[x], hn.rhostname[x], y, reply.banner[x][0], reply.helo[x][0], reply.mail_from[x][y], reply.rcpt_to[x][y]);
				}
				else if(o.track[x][y] == 3) {
					strip_chars(reply.banner[x][0]);
                                        strip_chars(reply.helo[x][0]);
                                        strip_chars(reply.mail_from[x][y]);
                                        strip_chars(reply.rcpt_to[x][y]);
					fprintf(fd, "%s,%s,%d,FAILED INITIAL TEST BUT DID NOT RELAY,%s,%s,%s,%s\n", hn.hostname[x], hn.rhostname[x], y, reply.banner[x][0], reply.helo[x][0], reply.mail_from[x][y], reply.rcpt_to[x][y]);
				}
				else if(o.track[x][y] == 4) {
					strip_chars(reply.banner[x][0]);
                                        strip_chars(reply.helo[x][0]);
                                        strip_chars(reply.mail_from[x][y]);
                                        strip_chars(reply.rcpt_to[x][y]);
					fprintf(fd, "%s,%s,%d,OPEN RELAY,%s,%s,%s,%s\n", hn.hostname[x], hn.rhostname[x], y, reply.banner[x][0], reply.helo[x][0], reply.mail_from[x][y], reply.rcpt_to[x][y]);
				}
				else if(o.track[x][y] == 5) {
					strip_chars(reply.banner[x][0]);
                                        strip_chars(reply.helo[x][0]);
                                        strip_chars(reply.mail_from[x][y]);
                                        strip_chars(reply.rcpt_to[x][y]);
					fprintf(fd, "%s,%s,%d,ANONYMOUS OPEN RELAY,%s,%s,%s,%s\n", hn.hostname[x], hn.rhostname[x], y, reply.banner[x][0], reply.helo[x][0], reply.mail_from[x][y], reply.rcpt_to[x][y]);
				}
			}
			else {
				if(o.track[x][y] == 3) {
					strip_chars(reply.banner[x][0]);
                                        strip_chars(reply.helo[x][0]);
                                        strip_chars(reply.mail_from[x][y]);
                                        strip_chars(reply.rcpt_to[x][y]);
                                        fprintf(fd, "%s,%s,%d,FAILED INITIAL TEST BUT DID NOT RELAY,%s,%s,%s,%s\n", hn.hostname[x], hn.rhostname[x], y, reply.banner[x][0], reply.helo[x][0], reply.mail_from[x][y], reply.rcpt_to[x][y]);
                                }
                                else if(o.track[x][y] == 4) {
					strip_chars(reply.banner[x][0]);
                                        strip_chars(reply.helo[x][0]);
                                        strip_chars(reply.mail_from[x][y]);
                                        strip_chars(reply.rcpt_to[x][y]);
                                        fprintf(fd, "%s,%s,%d,OPEN RELAY,%s,%s,%s,%s\n", hn.hostname[x], hn.rhostname[x], y, reply.banner[x][0], reply.helo[x][0], reply.mail_from[x][y], reply.rcpt_to[x][y]);
                                }
                                else if(o.track[x][y] == 5) {
					strip_chars(reply.banner[x][0]);
                                        strip_chars(reply.helo[x][0]);
                                        strip_chars(reply.mail_from[x][y]);
                                        strip_chars(reply.rcpt_to[x][y]);
                                        fprintf(fd, "%s,%s,%d,ANONYMOUS OPEN RELAY,%s,%s,%s,%s\n", hn.hostname[x], hn.rhostname[x], y, reply.banner[x][0], reply.helo[x][0], reply.mail_from[x][y], reply.rcpt_to[x][y]);
                                }
                        }
		}
	}
	
	fclose(fd);

	return(0);

}
				
			


void check_webdir(void) {

	char *d, *t = NULL;
	FILE *fp;

	if((fp=fopen(o.m_html_file, "w"))==NULL) {
		fprintf(stderr, "\n\nERROR\n\nUnable to open html file for writing\n\n\tExiting\n\n");
		exit(1);
	}
	fclose(fp);
	
	o.cp=s_malloc(strlen(o.m_html_file) * sizeof(char));
        strncpy(o.cp, o.m_html_file, strlen(o.m_html_file));
        d = o.cp;
        while(*++d) {
                if(*d == '/') {
                        t = d;
                }
        }
	if(t == NULL) {
		o.web_dir = "./";
		o.html_file=o.cp;
	}
	else {
		o.web_dir = o.cp;
        	o.html_file=t+1;
	}
       	if(strlen(o.html_file)<1) {
               	usage("smtprc");
               	exit(1);
        }
	if(t != NULL) {
        	*t = '\0';
	}
}

void print_html_header(FILE *fd) {

	char *title = "Smtp Relay Checker";
	int x;
	char flag = 0;

	//fprintf(fd, "Content-Type: text/html; charset=iso-8859-1\r\n\r\n");
	fprintf(fd, "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n");
        fprintf(fd, "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n");
        fprintf(fd, "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");
        fprintf(fd, "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n");
	fprintf(fd, "<html><head><title>%s</title></head><body text=\"black\" bgcolor=\"white\">\n", title);
	fprintf(fd, "<h1><br /><center>%s</center><br /><br /><hr /><hr /><br /><font size=2>All scans marked in <font color=\"red\"> Red</font> are definite open relays<br />All scans marked in <font color=\"black\"><bold>Black</bold></font> are also open relays but are anonymous or blind (This function is still being tested and those that report blind should be checked manually)<br />All scans marked in <font color=\"orange\"> Orange</font> have failed an initial test but didn't relay mail <br />All scans marked in <font color=\"blue\">Blue </font>have passed all of the tests<br /><br />\n", title);
	if(!f.send_email) {
		fprintf(fd, "Use the -b option to send emails through the the hosts marked in <font color=\"orange\">Orange</font> to confirm that they are open relays<br /><br />");
	}	
	else if(!f.check_mail) {
		fprintf(fd, "Check the emails sent to %s to confim that the hosts marked in <font color=\"orange\">Orange</font> are open relays!<br /><br />\n", o.email_addy2);
	}

	for(x=0;x<o.no_hostnames;x++) {
		if(o.track[x][o.no_rules+1]) {
			flag++;
		}
	}
	if(flag) {
		fprintf(fd, "<br />Click <bold /><font color=\"light blue\"><a href=\"timed-out.html\">HERE</a></font> for a list of servers that timed out while Reading/Writing<br />\n");
	}

}

int print_html_results(void) {

	int x = 0;
	int secs = 0;
	int mins = 0;
	int end_time;
	int flag = 0;

  if((o.m_html_fd = fopen(o.m_html_file, "w")) == NULL) {
		fprintf(stderr, "\n\tERROR:\nUnable to open file %s\n\n", o.m_html_file);
		exit(1);
	}

  print_html_header(o.m_html_fd);

	fprintf(o.m_html_fd, "<center><br /><br /><table cellpadding=\"2\"><tr>\n");

	for(x=0;x<o.no_hostnames;x++) {
		if(o.smtpopen[x] && !o.track[x][o.no_rules+1]) {
			if(o.display) {
				write_all(x, 1);
			}
			else {
				write_all(x, 0);
			}
		}
	}

	for(x=0;x<o.no_hostnames;x++) {
		if(o.track[x][o.no_rules+1]) {
			flag = 1;
		}
	}

	if(flag) {
		print_timed_out();
	}

	end_time = get_time();
  secs = (int)end_time-o.start_time;
  if(secs>60) {
  	mins = 0;
    while(secs>60) {
    	mins++;
      secs-=60;
    }
  }
  if(mins != -1 && mins != 0) {
  	fprintf(o.m_html_fd, "</center></tr></table><br /><hr /><center>Scanned %d hosts in %d mins and %d seconds<br />Spencer Hardy - diceman@dircon.co.uk<hr /><center>", (int)o.no_hostnames, mins, secs);
  }
  else {
  	fprintf(o.m_html_fd, "</center></tr></table><br /><hr /><center>Scanned %d hosts in %d seconds<br />Specer Hardy - diceman@dircon.co.uk<br /><hr /></center>", (int)o.no_hostnames, secs);
  }
	

	return(0);
}

void write_link(char *host, char *ip, char *color) {

	char name[30];
	char ip2[30];

	strncpy(name, host, 25);
	name[25] = '\0';
	
	strncpy(ip2, ip, 25);
	ip2[25] = '\0';

	if(o.passed % 5 == 0) {
		fprintf(o.m_html_fd, "</td><tr>\n");
	}

/*	if(f.get_hostname) {
		fprintf(o.m_html_fd, "<td width=\"10\"><a href=\"%s.html\"><font face=\"ariel\" size=3 color=\"%s\"><nobr>%s<br />(%s)&#9;</nobr></font></a></nobr></td>\n", ip2, color, name, ip2);
	}
	else {
*/
		fprintf(o.m_html_fd, "<td width=\"10\"><a href=\"%s.html\"><font face=\"ariel\" size=3 color=\"%s\"><nobr>%s&#9;</nobr></font></a></nobr></td>\n", ip2, color, name);
//	}

	o.passed++;

}

void write_page(FILE *fd, int host, int rule, char *color) {

	int rset = 0;

	if(f.get_hostname) {
		fprintf(fd, "<font color=\"%s\"><br /><b>Results for %s [%s] Rule %d</b>", color, hn.rhostname[host], hn.hostname[host], rule);
	}
	else {	
		fprintf(fd, "<font color=\"%s\"><br /><b>Results for %s Rule %d</b>", color, hn.hostname[host], rule);
	}
	fprintf(fd, "<pre>\tBANNER = %s\n", escape_html_chars(reply.banner[host][0]));
	if(f.verbose_html) {
		if(reply.helo[host][0]!=NULL) {
			fprintf(fd, "\tHELO SENT: %s\n", escape_html_chars(check_macro(nrules.helo[rule], host)));
			fprintf(fd, "\tHELO REPLY: %s\n", escape_html_chars(reply.helo[host][0]));
		}
		else {
			fprintf(fd, "\tRESET SENT: RSET\r\n\n");
      fprintf(fd, "\tRESET REPLY: %s\n</font></pre></font>", escape_html_chars(reply.rset[host][rule]));
      rset = 1;
    }
		if(reply.mail_from[host][rule]!=NULL && !rset) {
			fprintf(fd, "\tMAIL FROM SENT: %s\n", escape_html_chars(check_macro(nrules.mail_from[rule], host)));
			fprintf(fd, "\tMAIL FROM REPLY: %s\n", escape_html_chars(reply.mail_from[host][rule]));
		}
		else if(!rset){
			fprintf(fd, "\tRESET SENT: RSET\r\n\n");
    	fprintf(fd, "\tRESET REPLY: %s\n</font></pre></font>", escape_html_chars(reply.rset[host][rule]));
			rset = 1;
		}
		if(reply.rcpt_to[host][rule]!=NULL && !rset) {	
			fprintf(fd, "\tRCPT TO SENT: %s\n", escape_html_chars(check_macro(nrules.rcpt_to[rule], host)));
			fprintf(fd, "\tRCPT TO REPLY: %s\n", escape_html_chars(reply.rcpt_to[host][rule]));
		}
		else if(!rset){
			fprintf(fd, "\tRESET SENT: RSET\r\n\n");
      fprintf(fd, "\tRESET REPLY: %s\n</font></pre></font>", escape_html_chars(reply.rset[host][rule]));
			rset = 1;
    }
		if(reply.data[host][rule]!=NULL && !rset) {
			fprintf(fd, "\tDATA START SENT: DATA\r\n\n");
      fprintf(fd, "\tDATA START REPLY: %s\n", escape_html_chars(reply.data[host][rule]));
      fprintf(fd, "\tDATA SENT: %s\r\n", escape_html_chars(send_mail2(rule, host)));
      fprintf(fd, "\tDATA REPLY: %s\n", escape_html_chars(reply.data_end[host][rule]));
    }
		else if(!rset){
      fprintf(fd, "\tRESET SENT: RSET\r\n\n");
      fprintf(fd, "\tRESET REPLY: %s\n</font></pre></font>", escape_html_chars(reply.rset[host][rule]));
			rset = 1;
    }
		if(!rset) {
			fprintf(fd, "\tRESET SENT: RSET\r\n\n");
      fprintf(fd, "\tRESET REPLY: %s\n</font></pre></font>", escape_html_chars(reply.rset[host][rule]));
		}
	}
	else {
		if(reply.helo[host][0] != NULL) {
    	fprintf(fd, "\tHELO = %s\n", escape_html_chars(reply.helo[host][0]));
		}
		else {
			fprintf(fd, "\tDidn't recieve helo response\n");
		}
		if(reply.mail_from[host][rule] != NULL) {
			fprintf(fd, "\tMAIL FROM = %s\n", escape_html_chars(reply.mail_from[host][rule]));
		}
		if(reply.rcpt_to[host][rule]!=NULL) {
    	fprintf(fd, "\tRCPT TO = %s\n</font></pre></font>", escape_html_chars(reply.rcpt_to[host][rule]));
		}
  }
}

	

int write_all(int host, int all) {

	int x;
	int flag = 0;
	int quit = 1;
	int col = 0;
	char buf[MAXDATA+1];
	FILE *fd;
	char crap[30];
		
	if(!all) {
		for(x=0;x<o.no_rules;x++) {
			if(o.track[host][x] == 4 || o.track[host][x] == 3) {
				quit = 0;
			}
		}
		if(quit) {
			return(0);
		}
	}

	if(f.get_hostname) {
		strncpy(crap, hn.hostname[host], 25);
		crap[25] = '\0';
		snprintf(buf, MAXDATA, "%s/%s.html", o.web_dir, crap);
	}
	else {
		strncpy(crap, hn.hostname[host], 25);
		crap[25] = '\0';
		snprintf(buf, MAXDATA, "%s/%s.html", o.web_dir, crap);
	}	

	if((fd=fopen(buf, "w")) == NULL) {
		fprintf(stderr, "\n\nError opening output html file %s......... Quitting!\n\n", buf);
		exit(1);
	}

	//fprintf(fd, "Content-Type: text/html; charset=iso-8859-1\r\n\r\n");
	fprintf(fd, "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n");
	fprintf(fd, "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n");
    	fprintf(fd, "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");
	fprintf(fd, "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n");

	fprintf(fd, "<html><head><title>Results for %s</title></head><body><br /><br />\n", hn.hostname[host]);
	fprintf(fd, "<br /><hr /><center>SMTP Relay Checker<br />Spencer Hardy - diceman@dircon.co.uk</center><hr /><br />\n");


	for(x=0;x<o.no_rules;x++) {
		if(o.track[host][x] == 3) {
			if(col < 3) {
				col = 3;	
			}
		}
		if(o.track[host][x] == 4) {
			if(col < 4) {
      	col = 4;
			}
    }
		if(o.track[host][x] == 5) {
			if(col < 5) {
      	col = 5;
			}
    }
	}
	flag = 0;
	for(x=0;x<o.no_rules;x++) {
		if(col == 3) {
			if(!flag) {
				if(f.get_hostname) {
					write_link(hn.rhostname[host], hn.hostname[host], "orange");
				}
				else {
					write_link(hn.hostname[host], hn.hostname[host], "orange");
				}	
				flag = 1;
			}
		}
		else if(col == 4) {
			if(!flag) {
				if(f.get_hostname) {
					write_link(hn.rhostname[host], hn.hostname[host], "red");
				}
				else {
        	write_link(hn.hostname[host], hn.hostname[host], "red");
				}
				flag = 1;
			}
		}
		else if(col == 5) {
			if(!flag) {
				if(f.get_hostname) {
					write_link(hn.rhostname[host], hn.hostname[host], "black");
				}
				else {
					write_link(hn.hostname[host], hn.hostname[host], "black");
				}	
				flag = 1;
			}
		}
		else if(all) {
			if(!flag) {
				if(f.get_hostname) {
					write_link(hn.rhostname[host], hn.hostname[host], "blue");
				}
				else {
					write_link(hn.hostname[host], hn.hostname[host], "blue");
				}
				flag = 1;
			}
		}
		if(o.track[host][x] == 3) {
    	write_page(fd, host, x, "orange");
    }
    else if(o.track[host][x] == 4) {
    	write_page(fd, host, x, "red");
    }
    else if(o.track[host][x] == 5) {
    	write_page(fd, host, x, "black");
    }
    else if(all) {
    	write_page(fd, host, x, "blue");
    }
	}

	fprintf(fd, "<br /><hr /><center>SMTP Relay Checker<br />Spencer Hardy - diceman@dircon.co.uk</center><hr /></body></html>\n");

	fclose(fd);

	return(0);
}

void print_timed_out(void) {

	char buf[MAXDATA+1];
	FILE *fd;
	int x;
	int readf = 0;
	int writef = 0;
	int closedf = 0;

	snprintf(buf, MAXDATA, "%s/timed-out.html", o.web_dir);

	if((fd=fopen(buf, "w")) == NULL) {
		fprintf(stderr, "\n\nError opening output html file %s......... Quitting!\n\n", buf);
		exit(1);
	}

	for(x=0;x<o.no_hostnames;x++) {
		if(o.track[x][o.no_rules+1] == 1) {
			writef = 1;
		}
		if(o.track[x][o.no_rules+1] == 2) {
			readf = 1;
		}
		if(o.track[x][o.no_rules+1] == 3) {
			closedf = 1;
		}
	}

	//fprintf(fd, "Content-Type: text/html; charset=iso-8859-1\r\n\r\n");
	fprintf(fd, "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n");
        fprintf(fd, "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n");
        fprintf(fd, "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");
        fprintf(fd, "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n");
	fprintf(fd, "<html><head><title>Timed out checks</title></head><body><br /><br />\n");
	fprintf(fd, "<br /><hr /><center>SMTP Relay Checker<br />Spencer Hardy - diceman@dircon.co.uk</center><hr /><br />\n");

  if(readf) {
		fprintf(fd, "<p>Scans on the following servers were not completed due to read timeouts</p><br />");

		for(x=0;x<o.no_hostnames;x++) {
			if(o.track[x][o.no_rules+1] == 2) {
				if(f.get_hostname) {
					fprintf(fd, "<font color=\"blue\">%s<br />\n</font>", hn.rhostname[x]);
				}
				else {
					fprintf(fd, "<font color=\"blue\">%s<br />\n</font>", hn.hostname[x]);
				}
			}
		}
	}
	if(writef) {
		fprintf(fd, "<hr /><br /><br /><p>Scans on the following servers were not completed due to write timeouts</p ><br />");
		for(x=0;x<o.no_hostnames;x++) {
			if(o.track[x][o.no_rules+1] == 1) {
				if(f.get_hostname) {
					fprintf(fd, "<font color=\"blue\">%s<br /></font>\n", hn.rhostname[x]);
				}
				else {
					fprintf(fd, "<font color=\"blue\">%s<br /></font>\n", hn.hostname[x]);
				}
			}
		}
	}
	if(closedf) {
		fprintf(fd, "<hr /><br /><br /><p>Scans on the following servers were not completed due to the remote host closing the connection (Probably due to a firewall or other security feature)</p><br />");
		for(x=0;x<o.no_hostnames;x++) {
			if(o.track[x][o.no_rules+1] == 3) {
				if(f.get_hostname) {
					fprintf(fd, "<font color=\"blue\">%s<br /></font>\n", hn.rhostname[x]);
				}
				else {
					fprintf(fd, "<font color=\"blue\">%s<br /></font>\n", hn.hostname[x]);
				}
			}
		}
	}	

	fprintf(fd, "<br /><hr /><center>SMTP Relay Checker<br />Spencer Hardy - diceman@dircon.co.uk</center><hr /><br />\n");
	fclose(fd);
}
		
			
char *escape_html_chars(char *string) {

	char *p;
	//char *t;
	char buf[MAXDATA+1];
	char *return_string;

	int count = 0;

	memset(buf, 0x0, MAXDATA);

	if(string == NULL) { 
		return_string = s_malloc((strlen("NULL") +2) * sizeof(char));
		strncpy(return_string, "NULL", 4);
		return_string[5] = '\0';
		return(return_string);
	}

	p=string;
	do {
		if(*p == '<') {
			strncat(buf, "&lt;", MAXDATA);
			count+=4;
			continue;
		}
		if(*p == '>') {
      strncat(buf, "&gt;", MAXDATA);
			count+=4;
      continue;
    }
		buf[count] = *p;
		count++;
	} while(*p++ != '\0');

	return_string = s_malloc((strlen(buf) +1) * sizeof(char));
	strncpy(return_string, buf, strlen(buf));
	return_string[strlen(buf)] = '\0';

	return(return_string);

}
		
