/***************************************************************************
                          func.c  -  description
                             -------------------
    begin                : Fri Aug 10 2001
    copyright            : (C) 2001 by Spencer Hardy
    email                : diceman@dircon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "relay.h"



int malloc_mem_needed(void) {

	int x = 0;
	int y = 0;
	int hnames = o.no_hostnames+1;
	int nrules = o.no_rules+1;

	fprintf(stderr, "Allocating needed memory... Please wait!\n\n");

		/*The following code is to keep a track of wether the tests pass or fail
	   *track[o.no_hostname] has one varialble for each of the rules 0=fail 1=pass
	   *track[o.hostname][o.ruleno+1] tells wether the the check for that host
	   *finished completely 0=didn't finish (eg timeed out) 1=completed */


	o.track=s_malloc(hnames * sizeof(int *));
	o.smtpopen=s_malloc(hnames * sizeof(int *));
	o.readfds=s_malloc(hnames * sizeof(fd_set));
	for(x = 0;x<o.no_hostnames;x++) {
		o.track[x]=s_malloc((o.no_rules+5) * sizeof(int));
		o.smtpopen[x]=0;
	}
	for(x = 0;x<o.no_hostnames;x++) {
		for(y = 0;y<o.no_rules+5;y++) {
			o.track[x][y] = 0;
		}
	}
	if(o.debug) {
		fprintf(stderr, "no-rules == %d\n", o.no_rules);
	}

	/*The next lot is to keep track of the message relplies from the servers
	 *it's not very good for mem managment to keep track of all of the replies
	 *but it will be a little faster and it will allow easier formatting
	 *of printouts to html files */

	reply.banner=s_malloc((hnames) * sizeof(char ***));
	reply.helo=s_malloc((hnames) * sizeof(char ***));
	reply.mail_from=s_malloc((hnames) * sizeof(char ***));
	reply.rcpt_to=s_malloc((hnames) * sizeof(char ***));
	if(f.verbose_html) {
		reply.data=s_malloc((hnames) * sizeof(char ***));
		reply.data_end=s_malloc((hnames) * sizeof(char ***));
		reply.rset=s_malloc((hnames) * sizeof(char ***));
	}
	for(x=0;x<o.no_hostnames;x++) {
		reply.banner[x]=s_malloc((nrules) * sizeof(char **));
		reply.helo[x]=s_malloc((nrules) * sizeof(char **));
		reply.mail_from[x]=s_malloc((nrules) * sizeof(char **));
		reply.rcpt_to[x]=s_malloc((nrules) * sizeof(char **));
		if(f.verbose_html) {
			reply.data[x]=s_malloc((nrules) * sizeof(char **));
			reply.data_end[x]=s_malloc((nrules) * sizeof(char **));
			reply.rset[x]=s_malloc((nrules) * sizeof(char **));
		}
	}
	

	if(o.debug) {
		fprintf(stderr, "Finished allocating all memory\n\n o.hostnames == %d, o._no_rules == %d", (int)o.no_hostnames, o.no_rules);
		fflush(stderr);
	}
	return(0);

}

int free_mem_needed(void) {

	int x;
	int y;

  fprintf(stderr, "Freeing memory... Please wait!\n\n");

	for(x = 0;x<o.no_hostnames;x++) {
	  free(o.track[x]);
  }
  free(o.track);
  free(o.readfds);

  for(x=0;x<o.no_hostnames;x++) {
  	for(y=0;y<o.no_rules;y++) {
			free(reply.banner[x][y]);
      free(reply.helo[x][y]);
      free(reply.mail_from[x][y]);
      free(reply.rcpt_to[x][y]);
			if(f.verbose_html) {
      	free(reply.data[x][y]);
      	free(reply.data_end[x][y]);
      	free(reply.rset[x][y]);
			}
		}
	}
  for(x=0;x<o.no_hostnames;x++) {
  	free(reply.banner[x]);
    free(reply.helo[x]);
    free(reply.mail_from[x]);
    free(reply.rcpt_to[x]);
		if(f.verbose_html) {
    	free(reply.data[x]);
    	free(reply.data_end[x]);
    	free(reply.rset[x]);
		}
  }
	free(reply.banner);
  free(reply.helo);
  free(reply.mail_from);
  free(reply.rcpt_to);
	if(f.verbose_html) {
		free(reply.data);
		free(reply.data_end);
  	free(reply.rset);
	}

	return(0);
}

time_t get_time() {

	time_t timep;

	timep = time(NULL);
	return(timep);
}

int set_signals(void) {

	signal(SIGINT, sig_int);
	signal(SIGPIPE, sig_int2);
	signal(SIGHUP, sig_int);
	signal(SIGTERM, sig_int);
	signal(SIGSEGV, sig_int);
	return(0);
}

int mscan(void) {


	struct timespec tv;
	pthread_t tid;
	int flag = 0;
	int flag2 = 0;

	tv.tv_sec = 0;
	tv.tv_nsec = 500000000;

	//printf("In mscan\n");


	for(o.cur_host=0;o.cur_host<(o.no_hostnames);o.cur_host++) {
		STLOOP:
		if(o.cur_childs>=o.child) {
			if(o.debug) {
				fprintf(stderr, "Sleeping cur child == %d, max child == %d\n", o.cur_childs, o.child);
			}
			nanosleep(&tv, NULL);
			goto STLOOP;
		}
		else {
			TLOOP:
			if(pthread_create(&tid, NULL, (void *)thread_start, (int *)o.cur_host)) {
				if(!flag2) {
					fprintf(stderr, "** Failed to create thread!!\nIt's probably because you have set -p too high for this machine....\nUsing sleep() to compensate.... Try lowering the value of -p next time *shrugs*\n\n");
					flag2++;
				}
				usleep(100000);
				goto TLOOP;
			}
			else {
				if(o.debug) {
					fprintf(stderr, "Created thread\n");
				}
				o.cur_childs++;
			}
		}
		if(o.goat) {
			usleep(o.goat);
		}
	}
	while(o.cur_childs>0) {
		flag++;
		if(o.debug||o.verbose>1) {
			if(flag>20) {
				fprintf(stderr, "O.cur_childs(%d) id greater than zero...... sleepingz\n",o.cur_childs);
				flag = 0;
			}
		}
		nanosleep(&tv, NULL);
	}
	if(o.debug) {
		fprintf(stderr, "Printing results\n");
	}
	fflush(stdout);
	if(f.check_mail) {
		fprintf(stdout, "\nSleepin for %d seconds to allow all mails to arrive\n\n", o.email_timeout);
		sleep(o.email_timeout);
		check_mail();
	}
	if(f.txt_file) {
		print_txt_results();
	}
	if(f.m_html_file) {
		print_html_results();
	}
	if(f.print_machine) {
		print_m_results();
	}
	return(0);
}
		
		
int sscan(void) {


	return(0);
}

int thread_start(long cur_host) {

	int sockfd;
	long ip;
	int res;
	char hostnamer[MAXDATA+1];

	if(o.debug) {
		fprintf(stderr, "Starting thread_start process\n");
		fflush(stderr);
	}

	if(o.debug) {
		fprintf(stderr, "hostname == %s o.cur_host == %d\n",hn.hostname[cur_host], (int)cur_host);
	}
	if((ip = getip(hn.hostname[cur_host])) == -1) {
		o.track[cur_host][o.no_rules+1] = 4;
		if(o.debug) {
			fprintf(stderr, "Couldn't resolve ip\n");
		}
		fflush(stdout);
		o.cur_childs--;
		pthread_detach(pthread_self());
		pthread_exit(NULL);
		return(int)(NULL);
	}
	if(o.debug){
		fprintf(stderr, "Resolved ip\n");
	}
	fflush(stdout);
	if((sockfd = tcpconnect(ip)) != -1) {
		strncpy(hostnamer, get_hostname(hn.hostname[cur_host]), MAXDATA);
		if(f.get_hostname) {
			hn.rhostname[cur_host]=s_malloc((strlen(hostnamer)+1)*sizeof(char));
    	strncpy(hn.rhostname[cur_host], hostnamer, strlen(hostnamer));
    	hn.rhostname[cur_host][strlen(hostnamer)] = '\0';
		}
		o.smtpopen[cur_host] = 1;
		res = relay_check(sockfd, cur_host);
		close(sockfd);
	}
	else {
		o.track[cur_host][o.no_rules+2] = 1;
		if(o.debug) {
			fprintf(stderr, "Can't connect to %s\n", hn.hostname[cur_host]);
		}
	}
        o.cur_childs--;
	pthread_detach(pthread_self());
	pthread_exit(NULL);
	return(int)(NULL);

}


int check_mail(void) {

  FILE *fd;
  char buf[MAXDATA+1];
  char buf2[MAXDATA+1];
  int emails = 0;
  int emailsc = 0;
  int count = 0;
  int x = 0;
  int y = 0;
  int flag = 0;
  char *word;
  char email[MAXDATA+1];
  char tmp[9][MAXDATA+10];
  char *p;
  char *t=NULL;


  if((fd=fopen(o.mail_file, "r")) == NULL) {
    fprintf(stderr, "Unable to open %s for reading\n", o.mail_file);
    exit(1);
  }

  while(fgets(buf, MAXDATA, fd) != NULL) {
    if(!strncmp(buf, "From ", 5)) {
      emailsc = emails;
      for(word=strtok(buf, " ");word;word=strtok(NULL, " ")) {
        count++;
        if(count<8) {
          strncpy(tmp[count], word, MAXDATA-1);
        }
      }
      if(count > 3) {
        for(x=0;x<o.no_hostnames;x++) {
          if(!o.smtpopen[x]) {
	          continue;
 	        }
          for(y=0;y<o.no_rules;y++) {
            p=check_macro(nrules.mail_from[y], x);
            while(*p++) {
              if(*p == ':') {
                p++;
                t = p;
              }
            }
            if(t!=NULL) {
              strncpy(email, t, MAXDATA-1);
              email[strlen(t)-2] = '\0';
              if(!strncmp(tmp[2], email, strlen(email))) {
                emails++;
              }
            }
            t=NULL;
          }
        }
      }
      count = 0;
    }
    if(emailsc != emails) {
      count=0;
      if(!strncmp(buf, ":SmtpRCKey:", 11)) {
        for(word=strtok(buf, ":");word;word=strtok(NULL, ":")) {
          count++;
          if(count<5) {
            strncpy(tmp[count], word, MAXDATA-1);
          }
        }
        if(atoi(tmp[2]) == o.randomn) {
          for(x = 0;x < o.no_hostnames;x++) {
            y = 0;
            while(tmp[3][y]) {
							if(tmp[3][y] != hn.hostname[x][y]) {
                flag++;
              }
              y++;
            }
            if(!flag) {
              o.track[x][atoi(tmp[4])] = 4;
            }
            flag = 0;
            y = 0;
          }
        }
      }
    }
  }
    //Check for Blind or anonymous SMTP relay's
  rewind(fd);
  count = 0;
  while(fgets(buf, MAXDATA, fd) != NULL) {
    snprintf(buf2, MAXDATA, ":SmtpRCKey:%d", o.randomn);
    if(!strncmp(buf, buf2, strlen(buf2))) {
      for(word=strtok(buf, ":");word;word=strtok(NULL, ":")) {
        count++;
        if(count<5) {
          strncpy(tmp[count], word, MAXDATA);
        }
      }
      for(x=0;x<o.no_hostnames;x++) {
        if(!strncmp(hn.hostname[x], tmp[3], strlen(hn.hostname[x]))) {
          if(o.track[x][atoi(tmp[4])] == 3) {
            //printf("Found an anonymous server\n");
            o.track[x][atoi(tmp[4])] = 5;
          }
        }
      }
    }
  }
  return(0);
}	

int get_rand(void) {

	srand(time(NULL));

	o.randomn = rand() % 999999;
	o.randomn++;

	return(0);
}

int generate_config(void) {

	FILE *fd;

	fprintf(stderr, "Genrating configfile %s... Please wait\n\n\n", o.gen_config);

	if((fd=fopen(o.gen_config, "w")) == NULL) {
		fprintf(stderr, "\n\nUnable to open file \"%s\" to generate config... skipping\n\n", o.gen_config);
		return(0);
	}

	fprintf(fd, "##\n##\n##Smtp Relay Checker wuto generated config file");
	fprintf(fd, "\n##\n##\t\tSpencer Hardy\n\n#\n#\tdiceman@dircon.co.uk");
	fprintf(fd, "\n##\n##START\n##\n##");
	if(f.use_conf) {
		fprintf(fd, "\n\nCONFIGFILE:%s", o.config_file);
	}
	if(f.ip_range) {
		fprintf(fd, "\n\nIPRANGE:%s", o.ip_range2);
	}
	if(f.ip_list) {
		fprintf(fd, "\n\nIPLIST:%s", o.ip_list);
	}
	if(f.got_email) {
		fprintf(fd, "\n\nEMAILTEMPLATE:%s", o.email_file);
	}
	if(o.child) {
		fprintf(fd, "\n\nTHREADS:%d", o.child);
	}
	if(f.m_html_file) {
		fprintf(fd, "\n\nWEBPAGE:%s", o.m_html_file);
	}
	if(f.txt_file) {
                fprintf(fd, "\n\nTXTFILE:%s", o.txt_file);
        }
	if(f.send_email) {
		fprintf(fd, "\n\nRELAYEMAIL:%s", o.email_addy2);
	}
	if(f.check_mail) {
		fprintf(fd, "\n\nRELAYMAILBOX:%s", o.mail_file);
	}
	if(o.r_timeout) {
		fprintf(fd, "\n\nREADTIMEOUT:%d", o.r_timeout);
	}
	if(o.c_timeout) {
  	fprintf(fd, "\n\nCONNECTTIMEOUT:%d", o.c_timeout);
  }
	if(o.email_timeout) {
  	fprintf(fd, "\n\nWAITFORMAILTIME:%d", o.email_timeout);
  }	
	if(o.display) {
		fprintf(fd, "\n\nALLSCANS:Yes");
	}
	if(f.get_hostname) {
		fprintf(fd, "\n\nRESOLVEDOMAINS:Yes");
	}
	fprintf(fd, "\n#\n#\n#END");

	fflush(fd);
	fclose(fd);

	return(0);
}

char *get_hostname(const char *addr) {

	struct hostent *hn;
	struct in_addr *myaddr;

	myaddr=s_malloc(sizeof(struct in_addr));
  myaddr->s_addr=inet_addr(addr);


	if((hn = gethostbyaddr((char *) myaddr, 4, AF_INET)) == NULL) {
		return((char *)addr);
	}

	return((char *)hn->h_name);

}
