/***************************************************************************
                          main.c  -  description
                             -------------------
    email                : diceman@dircon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "relay.h"

//extern char *malloc_options;

int main(int argc, char **argv) {

	int scan_res = 0;
	int mins = -1;
	int secs;
	time_t end_time;
//	malloc_options = "Z";

	set_signals();

	banner();
	
	if((parse_args(argc, argv)) == -1) {
		usage(argv[0]);
	}
  	
	malloc_mem_needed();

	if(o.debug) fprintf(stderr, "Done parsing args2222222");

	if(o.m_html_file) {
		check_webdir();
	}

	if(f.gen_config) {
		fprintf(stdout, "Running the checks... Please wait\n\n");
	}
	else {
		fprintf(stdout, "Running the checks... Please wait\n\n\n");
	}
	fflush(stdout);
	o.start_time = get_time(); 
	
	if(f.gen_config) {
		generate_config();
	}

	if(o.child) {
		if(o.debug) {
			fprintf(stderr, "\nScanning with multiple processes\n");
		}
		scan_res = mscan();		//Scan using multiple processes
		if(o.debug) {
			fprintf(stderr, "Returning from mscan\n");
		}
	}
	else {
		if(o.debug) {
			fprintf(stderr, "\nScanning with single process\n");
		}
		fprintf(stderr, "Single process scanning hasn't been implemented\n\nyou must use the -p flag..... eg \t-p 100\n\nBye!");
		exit(1);
		scan_res = sscan();		//Scan using single processes
	}
	
	banner();
	end_time = get_time();
	secs = (int)end_time-o.start_time;
	if(secs>60) {
		mins = 0;
		while(secs>60) {
			mins++;
			secs-=60;
		}
	}
	if(mins!= -1 && mins != 0) {
		fprintf(stderr, "\n\tscanned %d hosts in %d mins and %d seconds\n\n", (int)o.no_hostnames, mins, secs);
	}
	else {
		fprintf(stderr, "\n\tscanned %d hosts in %d seconds\n\n", (int)o.no_hostnames, secs);
	}
	free_mem_needed();
	unlink("/tmp/tiplist");
	pthread_exit(NULL);
	return(0);
}

