/***************************************************************************
                          parse_funcs.c  -  description
                             -------------------
    begin                : Tue Apr 16 2002
    copyright            : (C) 2002 by Spencer Hardy
    email                : diceman@dircon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "relay.h"

int s_ip_range(char *ip) {

	char *t;
	char *p;
	char buf[MAXDATA+1];

	if(strstr(ip, "/")) {
		fprintf(stderr, "\n\nERROR\n\nNetmask notation is not supported yet...... please use the format 192.168.*.1-255\n\n");
		exit(1);
	}

	printf("\nCreating a list of IP's to scan....... Please wait!\n\n");


	if(strstr(ip, ",") == NULL) {
		get_ip_range(ip);
	}
	else {
		p = ip;
		t = p;
		while(*p++) {
			if(*p==',') {
				*p = '\0';
				p+=1;
				strncpy(buf, t, MAXDATA);
				get_ip_range(buf);
				t = p;
			}	
		}
		strncpy(buf, t, MAXDATA);
		get_ip_range(buf);
	}

	return(0);

}
			

int get_ip_range(char *iprange) {


	int start[4];
	int startc[4];
	int tstart[4];
	int tstartc[4];
	int end[4];
	int endc[4];
	int tend[4];
	int tendc[4];
	int i = 0;
	int hostnames = 0;
	char *r;
	char *addy[5];
	char *temp[2];
	char *iprange2;
	char hostnamet[MAXDATA+1];

	iprange2=s_malloc((strlen(iprange)+1) * sizeof(char));
	strncpy(iprange2, iprange, strlen(iprange));
	iprange2[strlen(iprange)] = '\0';

	addy[0] = addy[1] = addy[2] = addy[3] = addy[4] = NULL;

	addy[0] = r = iprange;

	while(*++r) {
		if (*r == '.' && ++i < 4) {
			*r = '\0';
			addy[i] = (r + 1);
		}
		else if (*r != '.' && *r != '*' && *r != '-' && !isdigit((int)*r) && *r != '\n') {
			fprintf(stderr, "\n\nERROR\n\nInvalid character in IP address notation\n\n");
			exit(1);
		}	
	}
	if(i!=3) {
		fprintf(stderr, "\n\nERROR\n\nIP address format is illegal\n\n");
		exit(1);
	}

	for(i=0;i<4;i++) {
		if(*addy[i] == '*') {
			if(i==0) {
				fprintf(stderr, "\n\nI don't think it's wise scanning then net\n\nBut if you sure then edit the source and remove this exit\n\n");
				exit(1);
			
			}
			if(i==1) {
				fprintf(stderr, "Sure you wanna scan a entire class A.... \n\n..... OK!\n\n");
			}
			start[i] = 1;
			startc[i] = 1;
			end[i] = 254;
			endc[i] = 254;
		}
		else {
			if((strstr(addy[i], "-")) != NULL) {
				temp[0] = addy[i];
				while(*addy[i] != '\n' && *addy[i] != '.' && *addy[i]) {
					if(*addy[i] == '-') {
						*addy[i] = '\0';
						temp[1] = addy[i] + 1;
						start[i] = atoi(temp[0]);
						startc[i] = atoi(temp[0]);
						end[i] = atoi(temp[1]);
						endc[i] = atoi(temp[1]);
					}
					else if (!isdigit((int)*addy[i])) {
						fprintf(stderr, "\n\nERROR\n\nInvalid host specification\n\n");
						exit(1);
					}	
					if(*addy[i]++){};
				}
			}
			else {
				start[i] = atoi(addy[i]);
				startc[i] = atoi(addy[i]);
				end[i] =  atoi(addy[i]);
				endc[i] =  atoi(addy[i]);
			}
		}
		tstart[i]=start[i];
		tstartc[i]=start[i];
		tend[i]=end[i];
		tendc[i]=endc[i];
		if((start[i] > end[i]) || (start[i]<0) || (end[i]>255)) {
			fprintf(stderr, "\n\nERROR\n\nInvalid ip range\n\n");
			exit(1);
		}
	}
	for(i=0;i<1;i++) {
		for(;start[i]<=end[i];start[i]++) {
			for(;start[i+1]<=end[i+1];start[i+1]++) {
				for(;start[i+2]<=end[i+2];start[i+2]++) {
					for(;start[i+3]<=end[i+3];start[i+3]++) {
						o.no_hostnames++;
					}
					start[i+3]=tstart[i+3];
					end[i+3]=tend[i+3];
				}
				start[i+2]=tstart[i+2];
				end[i+2]=tend[i+2];
			}
			start[i+1]=tstart[i+1];
			end[i+1]=tend[i+1];
		}
	}

	hn.hostname=s_malloc((o.no_hostnames+2) * sizeof(char **));
  if(f.get_hostname) {
    hn.rhostname=s_malloc((o.no_hostnames+2) * sizeof(char **));
  }
	
	for(i=0;i<1;i++) {
    for(;startc[i]<=endc[i];startc[i]++) {
      for(;startc[i+1]<=endc[i+1];startc[i+1]++) {
        for(;startc[i+2]<=endc[i+2];startc[i+2]++) {
          for(;startc[i+3]<=endc[i+3];startc[i+3]++) {
            if(o.debug) {
              fprintf(stderr, "list == %i.%i.%i.%i\n", startc[i], startc[i+1], startc[i+2], startc[i+3]);
              fprintf(stderr, "end --> %i.%i.%i.%i\n", endc[i], endc[i+1], endc[i+2], endc[i+3]);
            }
						snprintf(hostnamet, MAXDATA, "%i.%i.%i.%i", startc[i], startc[i+1], startc[i+2], startc[i+3]);
						hn.hostname[hostnames]=s_malloc((strlen(hostnamet)+1)*sizeof(char));
						strncpy(hn.hostname[hostnames], hostnamet, strlen(hostnamet));
						hn.hostname[hostnames][strlen(hostnamet)] = '\0';
						if(o.debug) {
							fprintf(stderr, "Hostname == %s", hn.hostname[hostnames]);
						}
						hostnames++;
          }
          startc[i+3]=tstartc[i+3];
          endc[i+3]=tendc[i+3];
        }
        startc[i+2]=tstartc[i+2];
        endc[i+2]=tendc[i+2];
      }
      startc[i+1]=tstartc[i+1];
      endc[i+1]=tendc[i+1];
    }
  }
	return(0);
}

int parseconfig(char *configfile) {



	FILE *fd;
	int i=0;
	int z=0;
	int nolines = 0;
	char *buf1;
	char buf2[3][250];
	char c;

	
	if((fd = fopen(configfile, "r")) == NULL) {
		fprintf(stderr, "**ERROR**\n\nUnable to open config file \"%s\"\n\n", configfile);
		exit(1);
	}
	

	while((c=fgetc(fd))!=EOF)
		if(c=='\n') nolines++;
	nolines++;
	rewind(fd);


	rules.helo=s_malloc((o.no_hostnames) * sizeof(char ***));
  rules.mail_from=s_malloc((o.no_hostnames) * sizeof(char ***));
  rules.rcpt_to=s_malloc((o.no_hostnames) * sizeof(char ***));

	for(i=0;i<o.no_hostnames;i++) {
		rules.helo[i]=s_malloc((nolines) * sizeof(char **));
		rules.mail_from[i]=s_malloc((nolines) * sizeof(char **));
		rules.rcpt_to[i]=s_malloc((nolines) * sizeof(char **));
	}

	i = 0;

	buf1=s_malloc((350+2) * sizeof(char));
	while(fgets(buf1,350,fd)) {
		if(buf1[0] == '#' || buf1[0] == '\n' || buf1[0] == ' ') continue;
		if((strstr(buf1, "--NAME--") != NULL) || (strstr(buf1, "--DOMAIN--") != NULL)) {
    	f.got_name = 1;
    }
		if(!f.get_hostname && (strstr(buf1, "--RELAY--") != NULL)) {
			fprintf(stderr, "\n\nERROR\n\nYou can only use the --RELAY-- macro's in the configuration file\nif you specify the -n option on the command line or set RESOLVEDOMAINS:Yes in the auto config file\n\n");
			exit(1);
		}	
		if(o.debug) {
			fprintf(stderr, "*fgets*\n%s\n\n",buf1);
		}
		if(sscanf(buf1, "%240s%240s%240s", buf2[0], buf2[1], buf2[2])==3) {
			for(z=0;z<o.no_hostnames;z++) {
//				fprintf(stderr, "*******\n%s\n%s\n%s\n*****", buf2[0], buf2[1], buf2[2]);
				fflush(stderr);
				rules.helo[z][i]=s_malloc(((strlen(buf2[0])+1) + strlen("HELO   ")) * sizeof(char));
				rules.mail_from[z][i]=s_malloc(((strlen(buf2[1])+1) + strlen("MAIL FROM:   ")) * sizeof(char));
				rules.rcpt_to[z][i]=s_malloc(((strlen(buf2[2])+1) + strlen("RCPT TO:   ")) * sizeof(char));
				snprintf(rules.helo[z][i], (strlen(buf2[0]) + strlen("HELO   "))+1, "HELO %s\r\n", buf2[0]);
				snprintf(rules.mail_from[z][i], (strlen(buf2[1]) + strlen("MAIL FROM:  "))+1, "MAIL FROM:%s\r\n", buf2[1]);
				snprintf(rules.rcpt_to[z][i], (strlen(buf2[2]) + strlen("RCPT TO:  "))+1, "RCPT TO:%s\r\n", buf2[2]);
//				rules.helo[z][i][(strlen(buf2[0]) + strlen("HELO   "))] = '\0';
//				rules.mail_from[z][i][(strlen(buf2[1]) + strlen("MAIL FROM:  "))] = '\0';
//				rules.rcpt_to[z][i][(strlen(buf2[2]) + strlen("RCPT TO:  "))] = '\0';
//				fprintf(stderr, "*************rules\n%s%s%s**************i == %d, z == %d", rules.helo[z][i], rules.mail_from[z][i], rules.rcpt_to[z][i], i, z);
			}
			o.no_rules++;
			i++;
		}
	}

	fclose(fd);
	return(0);
	
}

void setup_rules(char *configfile) {

	FILE *fd;
	char buf[351];
	char buf2[3][351];
	int i = 0;


	if((fd = fopen(configfile, "r")) == NULL) {
    fprintf(stderr, "**ERROR**\n\nUnable to open config file \"%s\"\n\n", configfile);
    exit(1);
  }

	while(fgets(buf,350,fd)) {
    if(buf[0] == '#' || buf[0] == '\n' || buf[0] == ' ') {
      continue;
    }
		if(sscanf(buf, "%240s%240s%240s", buf2[0], buf2[1], buf2[2])==3) {
			o.no_rules++;
		}
	}

	rewind(fd);

	nrules.helo = s_malloc((o.no_rules +1) * sizeof(char **));
	nrules.mail_from = s_malloc((o.no_rules +1) * sizeof(char **));
	nrules.rcpt_to = s_malloc((o.no_rules +1) * sizeof(char **));

	while(fgets(buf,350,fd)) {
		if(buf[0] == '#' || buf[0] == '\n' || buf[0] == ' ') {
			continue;
		}
		if((strstr(buf, "--NAME--") != NULL) || (strstr(buf, "--DOMAIN--") != NULL)) {
      f.got_name = 1; 
    }
		if(!f.get_hostname && strstr(buf, "--RELAY--") != NULL) {
			fprintf(stderr, "\n\nERROR\n\nYou can only use the --RELAY-- macro's in the configuration file\nif you specify the -n option on the command line or set RESOLVEDOMAINS:Yes in the auto config file\n\n");
			exit(1);
		}
		if(sscanf(buf, "%240s%240s%240s", buf2[0], buf2[1], buf2[2])==3) {
			nrules.helo[i] = s_malloc(((strlen(buf2[0])+1) + strlen("HELO   ")) * sizeof(char));
			nrules.mail_from[i] = s_malloc(((strlen(buf2[1])+1) + strlen("MAIL FROM:   ")) * sizeof(char));
			nrules.rcpt_to[i] = s_malloc(((strlen(buf2[2])+1) + strlen("RCPT TO:   ")) * sizeof(char));
			snprintf(nrules.helo[i], (strlen(buf2[0]) + strlen("HELO   "))+1, "HELO %s\r\n", buf2[0]);
    	snprintf(nrules.mail_from[i], (strlen(buf2[1]) + strlen("MAIL FROM:  "))+1, "MAIL FROM:%s\r\n", buf2[1]);
    	snprintf(nrules.rcpt_to[i], (strlen(buf2[2]) + strlen("RCPT TO:  "))+1, "RCPT TO:%s\r\n", buf2[2]);
		}
		i++;
	}

	fclose(fd);
}


char *swap_macro(char *rule, char *macro, int i) {

	char *p;
	char string3[MAXDATA+1];
	char *string4;

	strncpy(string3, rule, MAXDATA);

	
  p = strstr(rule, macro);
	if(p != NULL) {
		memcpy(string3, rule, p - rule);
		string3[p - rule] = '\0';
		p	+= strlen(macro);
		if(!strncmp(macro, "--HOSTNAME--", strlen(macro))) {
			strncat(string3, hn.hostname[i], MAXDATA);
		}
		else if(!strncmp(macro, "--NAME--", strlen(macro))) {
			strncat(string3, o.name, MAXDATA);
		}
		else if(!strncmp(macro, "--DOMAIN--", strlen(macro))) {
			strncat(string3, o.domain, MAXDATA);
		}
		else if(!strncmp(macro, "--RELAY--", strlen(macro))) {
			strncat(string3, hn.rhostname[i], MAXDATA);
		}	
		strncat(string3, p, MAXDATA);
	}

	string4=s_malloc((strlen(string3)+1) * sizeof(char));
	strncpy(string4, string3, strlen(string3));
	string4[strlen(string3)] = '\0';

	return(string4);
	
}

char *swap_macro2(char *string, char *macro, char *swap) {

  char *p;
  char string3[MAXDATA+1];
  char *string4;

  strncpy(string3, string, MAXDATA);


  p = strstr(string, macro);
  if(p != NULL) {
    memcpy(string3, string, p - string);
    string3[p - string] = '\0';
    p += strlen(macro);
    strncat(string3, swap, MAXDATA);
    strncat(string3, p, MAXDATA);
  }

  string4=s_malloc((strlen(string3)+1) * sizeof(char));
  strncpy(string4, string3, strlen(string3));
  string4[strlen(string3)] = '\0';

  return(string4);

}


int correct_config(void) {

	int i = 0;
	int z = 0;
	char tmp[MAXDATA+1];

	for(i=0;i<o.no_hostnames;i++) {
		for(z=0;z<o.no_rules;z++) {
	
			strncpy(tmp, rules.helo[i][z], MAXDATA);
			rules.helo[i][z]=swap_macro(tmp, "--RELAY--", i);
			strncpy(tmp, rules.helo[i][z], MAXDATA);
			rules.helo[i][z]=swap_macro(tmp, "--HOSTNAME--", i);
			strncpy(tmp, rules.helo[i][z], MAXDATA);
			rules.helo[i][z]=swap_macro(tmp, "--NAME--", i);
			strncpy(tmp, rules.helo[i][z], MAXDATA);
			rules.helo[i][z]=swap_macro(tmp, "--DOMAIN--", i);
			strncpy(tmp, rules.mail_from[i][z], MAXDATA);
			rules.mail_from[i][z]=swap_macro(tmp, "--RELAY--", i);
			strncpy(tmp, rules.mail_from[i][z], MAXDATA);
			rules.mail_from[i][z]=swap_macro(tmp, "--HOSTNAME--", i);
			strncpy(tmp, rules.mail_from[i][z], MAXDATA);
			rules.mail_from[i][z]=swap_macro(tmp, "--NAME--", i);
			strncpy(tmp, rules.mail_from[i][z], MAXDATA);
			rules.mail_from[i][z]=swap_macro(tmp, "--DOMAIN--", i);
			strncpy(tmp, rules.rcpt_to[i][z], MAXDATA);
			rules.rcpt_to[i][z]=swap_macro(tmp, "--RELAY--", i);
			strncpy(tmp, rules.rcpt_to[i][z], MAXDATA);
			rules.rcpt_to[i][z]=swap_macro(tmp, "--HOSTNAME--", i);
			strncpy(tmp, rules.rcpt_to[i][z], MAXDATA);
			rules.rcpt_to[i][z]=swap_macro(tmp, "--NAME--", i);
			strncpy(tmp, rules.rcpt_to[i][z], MAXDATA);
			rules.rcpt_to[i][z]=swap_macro(tmp, "--DOMAIN--", i);
			//printf("helo == %s\t mf == %s\t rcpt == %s\n", rules.helo[i][z], rules.mail_from[i][z], rules.rcpt_to[i][z]);
		}
	}

	return(0);
}

char *check_macro(char *string, int cur_host) {

	char string2[MAXDATA+1];
	char *string3;

	strncpy(string2, string, MAXDATA);
	string2[MAXDATA] = '\0';

	if(f.get_hostname) {
		if(strstr(string, "--RELAY--") != NULL) {
			strncpy(string2, swap_macro2(string2, "--RELAY--", hn.rhostname[cur_host]), MAXDATA);
			string2[MAXDATA] = '\0';
		}
	}
	if(strstr(string, "--HOSTNAME--") != NULL) {
    strncpy(string2, swap_macro2(string2, "--HOSTNAME--", hn.hostname[cur_host]), MAXDATA);
		string2[MAXDATA] = '\0';
  }
	if(strstr(string, "--NAME--") != NULL) {
    strncpy(string2, swap_macro2(string2, "--NAME--", o.name), MAXDATA);
		string2[MAXDATA] = '\0';
  }
	if(strstr(string, "--DOMAIN--") != NULL) {
    strncpy(string2, swap_macro2(string2, "--DOMAIN--", o.domain), MAXDATA);
		string2[MAXDATA] = '\0';
  }

	string3 = s_malloc((strlen(string2)+1) * sizeof(char));
	strncpy(string3, string2, strlen(string2));
	string3[strlen(string2)] = '\0';
	//free(string2);
	//printf("Returning *%s*\n", string3);
	return(string3);

}

int get_domain() {

	char *p;
	char *t;
	char email[strlen(o.email_addy)+1];
	int flag = 0;

	strncpy(email, o.email_addy, sizeof(email));

	p = o.email_addy;

	while(*p++) {
		if(*p == '\0' || isalnum((int)*p) || *p == '.' || *p == '-' || *p == '_' || *p == '@') {
			if(*p == '@') {
				flag++;
				t = p;
				if(!isalnum((int)*++t)) {
					fprintf(stderr, "The email address you have supplied %s is incorrect!!\n\n\n", email);
                        		exit(1);
				}
				t = p;
				if(!isalnum((int)*--t)) {
                                        fprintf(stderr, "The email address you have supplied %s is incorrect!!\n\n\n", email);
                                        exit(1);
                                }
				t = p;
				*t = '\0';
				t++;	
				p++;
			}
		}
		else {
			fprintf(stderr, "The email address you have supplied %s is incorrect!!\n\n\n", email);
                	exit(1);
		}
	}
	if(!flag||flag>2) {
		fprintf(stderr, "The email address you have supplied %s is incorrect!!\n\n\n", email);
		exit(1);
	}
	o.domain=s_malloc((strlen(t)+1) * sizeof(char));
	strncpy(o.domain, t, strlen(t));
	o.domain[strlen(t)] = '\0';
	o.name=s_malloc((strlen(o.email_addy)+1) * sizeof(char));
	strncpy(o.name, o.email_addy, strlen(o.email_addy));
	o.name[strlen(o.email_addy)] = '\0';

	return(0);
}

int parse_aconfig() {


	FILE *fd;
	char buf[MAXDATA];
	char *p;


	if((fd = fopen(o.aconfig, "r")) == NULL) {	
		fprintf(stderr, "**ERROR**\n\nUnable to open auto config file %s\n\n", o.aconfig);
		exit(1);
	}

	while(fgets(buf, MAXDATA-1, fd)!=NULL) {
		if(buf[0] == '#' || buf[1] == '#' || buf[0] == ' ' || buf[0] == '\n') {
			continue;
		}
		
		if(!strncmp(buf, "IPRANGE:", 8)) {
			p = &buf[8];
			f.ip_range = 1;
      o.ip_range=s_malloc((strlen(p)+1)*sizeof(char));
      strncpy(o.ip_range, p, strlen(p));
      o.ip_range[strlen(p)-1] = '\0';
		}
		else if(!strncmp(buf, "CONFIGFILE:", 11)) {
			p = &buf[11];
			f.use_conf = 1;
      o.config_file=s_malloc((strlen(p)+1)*sizeof(char));
      strncpy(o.config_file, p, strlen(p));
      o.config_file[strlen(p)-1]='\0';
    }
		else if(!strncmp(buf, "WEBPAGE:", 8)) {
			p = &buf[8];
			f.m_html_file = 1;
      o.m_html_file=s_malloc((strlen(p)+2) * sizeof(char));
      strncpy(o.m_html_file, p, strlen(p)+1);
      o.m_html_file[strlen(p)-1] = '\0';
      open_file(o.m_html_file);		
		}
		else if(!strncmp(buf, "THREADS:", 8)) {
			p = &buf[8];
			o.child = atoi(p);
		}
		else if(!strncmp(buf, "IPLIST:", 7)) {
			p = &buf[7];
			if(f.ip_range) {
				fprintf(stderr, "i\n\n**ERROR**\n\nIPLIST and IPRANGE can'tboth be define in the config file\n\n");
				exit(1);
			}
      f.ip_list = 1;
      o.ip_list=s_malloc((strlen(p)+2)*sizeof(char)+1);
      strncpy(o.ip_list, p, strlen(p)+1);
      o.ip_list[strlen(p)-1] = '\0';
    }
		else if(!strncmp(buf, "RELAYEMAIL:", 11)) {
			p = &buf[11];
			f.send_email = 1;
      o.email_addy=s_malloc((strlen(p)+1)*sizeof(char));
      o.email_addy2=s_malloc((strlen(p)+1)*sizeof(char));
      strncpy(o.email_addy, p, strlen(p));
      strncpy(o.email_addy2, p, strlen(p));
      o.email_addy[strlen(p)-1]='\0';
      o.email_addy2[strlen(p)-1]='\0';
		}
		else if(!strncmp(buf, "RELAYMAILBOX:", 13)) {
			p = &buf[13];
			f.check_mail = 1;
      o.mail_file=s_malloc((strlen(p)+1)*sizeof(char));
      strncpy(o.mail_file, p, strlen(p));
			o.mail_file[strlen(p)-1] = '\0';
		}		
		else if(!strncmp(buf, "RESULTSEMAIL:", 13)) {
			p = &buf[13];
			f.email_results = 1;
			o.email_results=s_malloc((strlen(p)+1)*sizeof(char));
			strncpy(o.email_results, p, strlen(p));
      o.email_results[strlen(p)-1] = '\0';
		}
		else if(!strncmp(buf, "ALLSCANS:", 9)) {
			p = &buf[9];
			if(!strncmp(p, "Yes", 3)||!strncmp(p, "YES", 3)||!strncmp(p, "yes", 3)) {
				o.display++;
			}
		}
		else if(!strncmp(buf, "RESOLVEDOMAINS:", 15)) {
      p = &buf[15];
      if(!strncmp(p, "Yes", 3)||!strncmp(p, "YES", 3)||!strncmp(p, "yes", 3)) {
      	f.get_hostname++;
      }
    }
		else if(!strncmp(buf, "CONNECTTIMEOUT:", 15)) {
			p = &buf[15];
			o.c_timeout = atoi(p);
		}
		else if(!strncmp(buf, "READTIMEOUT:", 12)) {
      p = &buf[12];
      o.r_timeout = atoi(p);
		}
		else if(!strncmp(buf, "WAITFORMAILTIME:", 16)) {
      p = &buf[16];
			o.email_timeout = atoi(p);
		}
		else if(!strncmp(buf, "EMAILTEMPLATE:", 14)) {
			p = &buf[14];
			f.got_email = 1;
			o.email_file=s_malloc((strlen(p)+1)*sizeof(char));
      strncpy(o.email_file, p, strlen(p));
			o.email_file[strlen(p)-1] = '\0';
		}
		else if(!strncmp(buf, "VERBOSEHTML:", 12)) {
      p = &buf[12];
      if(!strncmp(p, "Yes", 3)||!strncmp(p, "YES", 3)||!strncmp(p, "yes", 3)) {
        f.verbose_html = 1;
      }
    }
		else {
			fprintf(stderr, "**ERROR**\n\nDetected error \"%s\" in configuration file... Exiting\n", buf);
			exit(1);
		}
	}
	
	return(0);
}

int get_email_file(char *email_file) {

	FILE *fd;

	char *p;
	char *t;
	char *s;
	char buf[MAXDATA+1];
	char c;
	char *temp;

	int subject = 0;
	int body = 0;
	int rflag=0;
	int nflag=0;
	int size=0;
	int count = 0;

	if((fd=fopen(email_file, "r"))==NULL) {
		fprintf(stderr, "\n\nERROR:\n\nUnable to open the email file [%s] you specified\nDo you wan to continue using the default?\n\n"
										"Continue:\t[y] [n]\n:", email_file);		
		if((c=fgetc(stdin)) == 'y' || ((c=fgetc(stdin)) == 'Y')) {
			f.got_email = 0;
			return(1);
		}
		else {
			exit(1);
		}
	}

	while(fgets(buf, MAXDATA, fd)) {
		if(!strncmp(buf, "SUBJECT:", 8)) {
			subject = 1;
			p = buf+8;
			if(*p!='\0') {
				if(o.debug) {
					fprintf(stderr, "DEBUG: email subject == [%s]\n", p);
				}
				size=strlen(p);
				if((t=strstr(p, "ENDSUBJECT"))!=NULL) {
					*t = '\0';
					size=strlen(p);
					o.email_subject=s_malloc((size+1) * sizeof(char));
					strncpy(o.email_subject, p, size);
					o.email_subject[size]='\0';
          break;
				}
				o.email_subject=s_malloc((size+1) * sizeof(char));
				strncpy(o.email_subject, p, size);
				o.email_subject[size]='\0';
			}
			do {
				if(fgets(buf, MAXDATA, fd)==NULL) {
					subject = 0;
					break;
				}
				size+=strlen(buf);
				if(o.debug) {
          fprintf(stderr, "DEBUG: email subject == [%s]\r\n", buf);
        }
				if((t=strstr(buf, "ENDSUBJECT"))!=NULL) {
          *t = '\0';
					size+=strlen(buf);
					if((o.email_subject=realloc(o.email_subject, (size+2) * sizeof(char))) == NULL) {
						fprintf(stderr, "\n\nERROR:\n\nRealloc Error...... Quitting\n");
						exit(1);
					}
        	strncat(o.email_subject, buf, size);
        	o.email[size]='\0';
					break;
				}
				if((o.email_subject=realloc(o.email_subject, (size+1) * sizeof(char))) == NULL) {
           fprintf(stderr, "\n\nERROR:\n\nRealloc Error...... Quitting\n");
        	 exit(1);
        }
        strncat(o.email_subject, buf, size);
        o.email[size]='\0';
			} while(strstr(buf, "ENDSUBJECT") == NULL);
		}
	}

	rewind(fd);

	while(fgets(buf, MAXDATA, fd)) {
    if(!strncmp(buf, "BODY:", 5)) {
      body = 1;
      p = buf+5;
      if(*p!='\0') {
        if(o.debug) {
          fprintf(stderr, "DEBUG: email body == [%s]\n", p);
        }
				size=strlen(p);
				if((t=strstr(buf, "ENDBODY"))!=NULL) {
					*t = '\0';
					size=strlen(buf);
        	o.email=s_malloc((size+1) * sizeof(char));
        	strncpy(o.email, p, size);
        	o.email[size]='\0';
          break;
				}
        o.email=s_malloc((size+1) * sizeof(char));
        strncpy(o.email, p, size);
        o.email[size]='\0';
      }
      do {
        if(fgets(buf, MAXDATA, fd)==NULL) {
					body = 0;
					break;
				}
				size+=strlen(buf);
        if(o.debug) {
          fprintf(stderr, "DEBUG: email body == [%s]\n", buf);
        }
				if((t=strstr(buf, "ENDBODY"))!=NULL) {
					*t = '\0';
					size+=strlen(buf);
        	if((o.email=realloc(o.email, (size+1) * sizeof(char))) == NULL) {
          	fprintf(stderr, "\n\nERROR:\n\nRealloc Error...... Quitting\n");
          	exit(1);
        	}
        	strncat(o.email, buf, size);
        	o.email[size]='\0';
					break;
				}
				if((o.email=realloc(o.email, (size+1) * sizeof(char))) == NULL) {
          fprintf(stderr, "\n\nERROR:\n\nRealloc Error...... Quitting\n");
          exit(1);
        }
        strncat(o.email, buf, size);
        o.email[size]='\0';
      } while(strstr(buf, "ENDBODY")==NULL);
		}
  }

	if(!body || !subject) {
		fprintf(stderr, "\n\nERROR:\n\nEmail file is in the wrong format\n"
										"Do you want to continue using the default?\n"
										"\nContinue\t[y] [n]\t:"); 
		if((c=fgetc(stdin)) == 'y' || ((c=fgetc(stdin)) == 'Y')) {
      f.got_email = 0;
      return(1);
    }
    else {
      exit(1);
    }
  }
	if(!o.email) {
		fprintf(stderr, "\n\nERROR:\n\nThe body of your email is empty\n"
                    "Do you want to continue using the default?\n"
                    "\nContinue\t[y] [n]\t:");
		if((c=fgetc(stdin)) == 'y' || ((c=fgetc(stdin)) == 'Y')) {
      f.got_email = 0;
      return(1);
    }
    else {
      exit(1);
    }
  }
	if(!o.email_subject) {
		fprintf(stderr, "\n\nERROR:\n\nThe subject of your email is empty\n"
                    "Do you want to continue using the default?\n"
                    "\nContinue\t[y] [n]\t:");
		if((c=fgetc(stdin)) == 'y' || ((c=fgetc(stdin)) == 'Y')) {
      f.got_email = 0;
      return(1);
    }
    else {
      exit(1);
    }
  }
	if(strlen(o.email)<2) {
		fprintf(stderr, "\n\nERROR:\n\nThe body of your email contains 1 character\n"
                    "Do you want to continue using the default?\n"
                    "\nContinue\t[y] [n]\t:");
		if((c=fgetc(stdin)) == 'y' || ((c=fgetc(stdin)) == 'Y')) {
      f.got_email = 0;
      return(1);
    }
    else {
      exit(1);
    }
  }
	if(strlen(o.email_subject)<2) {
		fprintf(stderr, "\n\nERROR:\n\nThe subject of your email contains 1 character\n"
                    "Do you want to continue using the default?\n"
                    "\nContinue\t[y] [n]\t:");
		if((c=fgetc(stdin)) == 'y' || ((c=fgetc(stdin)) == 'Y')) {
      f.got_email = 0;
      return(1);
    }
    else {
      exit(1);
    }
  }

	p=o.email_subject;
	do {
		if(*p == '\n') {
			nflag++;
		}
		if(*p == '\r') {
			rflag++;
		}
	}	while(*p++!='\0'); 
	if(nflag > 1 || rflag > 1) {
		fprintf(stderr, "\n\nERROR:\n\nThere is more than one line feed in the email subject\n"
                    "Do you want to continue using the default?\n"
                    "\nContinue\t[y] [n]\t:");
    if((c=fgetc(stdin)) == 'y' || ((c=fgetc(stdin)) == 'Y')) {
      f.got_email = 0;
      return(1);
    }
    else {
      exit(1);
    }
  }
	else if(nflag == 0 && rflag == 0) {
		strcat(o.email_subject, "\r\n");
	}
	else if(nflag == 0 && rflag == 1) {
    strcat(o.email_subject, "\r");
  }
	else if(nflag == 1 && rflag == 1) {
		nflag = 0;
		rflag = 0;
		p=o.email_subject;
		do {
    	if(*p == '\n') {
				s=p;
				if(--*s == '\r') {
					rflag++;
				}
    	}
  	} while(*p++!='\0');
		if(!rflag) {
			fprintf(stderr, "\n\nERROR:\n\nThere is supurious carraige return in the subject\n"
                    "Do you want to continue using the default?\n"
                    "\nContinue\t[y] [n]\t:");
    	if((c=fgetc(stdin)) == 'y' || ((c=fgetc(stdin)) == 'Y')) {
      	f.got_email = 0;
      	return(1);
    	}
    	else {
      	exit(1);
    	}
  	}
	}
	temp=s_malloc((strlen(o.email)+1) * sizeof(char));
	strncpy(temp, o.email, strlen(o.email));
	p=temp;
	rflag = 0;
	count = 0;
	memset(buf, 0x0, MAXDATA);
	do {
		if(*p == '\n') {
			if(!count) {
        strncat(buf, "\r\n", MAXDATA);
				rflag++;
				rflag++;
        continue;
      }
			s=p;
      if(--*s != '\r') {
				strncat(buf, "\r\n", MAXDATA);
				rflag++;
				rflag++;
        continue;
      }
		}
		if(*p == '\0') {
			break;
		}
		buf[rflag] = *p;
		count++;
		rflag++;
	} while(*p++!='\0');	
	if((o.email=realloc(o.email, (strlen(buf)+1) * sizeof(char))) == NULL) {
   	fprintf(stderr, "\n\nERROR:\n\nRealloc Error...... Quitting\n");
    exit(1);
  }
  strncpy(o.email, buf, strlen(buf));
  o.email[strlen(buf)]='\0';
	if(o.debug) {
		fprintf(stderr, "DEBUG: end subject == [%s]\n", o.email_subject);
		fprintf(stderr, "DEBUG: end body == [%s]\n", o.email);
	}

	return(0);

}

int *parse_ip_list(char *iplist) {

	FILE *fd;
	int nolines = 0;
	int i = 0;
	char hostnamet[MAXDATA];
	//char hostnamer[MAXDATA];
	char c;
	char *buffer;

	if((fd = fopen(iplist, "r")) == NULL) {
		fprintf(stderr, "Unable to open ip list %s\n", iplist);
		exit(1);
	}
	buffer=s_malloc((355+2) * sizeof(char));
	while((c=fgetc(fd))!=EOF) {
		if(c=='\n') {
			nolines++;
		}
	}

	rewind(fd);

	hn.hostname=s_malloc((nolines+2) * sizeof(char **));
	if(f.get_hostname) {
		hn.rhostname=s_malloc((nolines+2) * sizeof(char **));
	}
	while(fgets(buffer,250,fd)) {
		if(o.debug) {
			fprintf(stderr, "\n%s\n",buffer);
		}
		if(buffer[0] == '#' || buffer[0] == '\n' || buffer[0] == ' ') {
			continue;
		}
		if(sscanf(buffer, "%250s", hostnamet)==1) {
			hn.hostname[i]=s_malloc((strlen(hostnamet)+1)*sizeof(char));
			if(f.get_hostname) {
				/*strncpy(hostnamer, get_hostname(hostnamet), MAXDATA);
				hn.rhostname[i]=s_malloc((strlen(hostnamer)+1)*sizeof(char));
				strncpy(hn.rhostname[i], hostnamer, strlen(hostnamer));
				hn.rhostname[i][strlen(hostnamer)] = '\0';
			*/
			}	
			strncpy(hn.hostname[i], hostnamet, strlen(hostnamet));
			hn.hostname[i][strlen(hostnamet)] = '\0';
			if(o.debug) {
				if(f.get_hostname) {
        	fprintf(stderr, "hn.rhostname[i] == %s\n", hn.rhostname[i]);
				}
				fprintf(stderr, "hn.hostname[i] == %s\n", hn.hostname[i]);
			}
			o.no_hostnames++;
			i++;
		}
	}
	fclose(fd);
	return(0);
}


		
