/***************************************************************************
                          relay.h  -  description
                             -------------------
    email                : diceman@dircon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


/*****************************INCLUDES**************************************/


#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <strings.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <unistd.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <signal.h>
#include <sys/time.h>
#include <ctype.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <sys/file.h>
#include <netdb.h>
#include <pthread.h>
#include <netdb.h>
#include <time.h>


/****************************DEFINES****************************************/

#ifndef _REENTRANT
#define _REENTRANT
#endif
#define PORT 25
#define MAXDATA 8129
#define CIMEO 10
#define RTIMEO 60
#define EMAILTIMEOUT 60
#define HELO "HELO ";
#define MAILFROM "MAIL FROM: ";
#define RCPTTO "RCPT TO: ";
#define FAILED -1;
#define PASSED 1;
#define RELAY "--relay--";
#ifndef MSG_NOSIGNAL
#define MSG_NOSIGNAL        0x4000
#endif

/***************************PROTOTYPES*************************************/


int get_domain();
int get_email_file(char *email_file);
int check_cons(char *pname);
void *s_malloc(int size);
int tcpconnect(long ipa);
int usage(char *pname);
int connect_timeo(int sockfd, const struct sockaddr *thaddr, socklen_t salen, int nsec);
int banner(void);
int parse_args(int argc, char * const *argv);
int parseconfig(char *configfile);
int quitsmtp(int sockfd, int cur_host, int rule);
void sig_int(int signo);
void sig_int2(int signo);
void connect_alarm(int signo);
int *parse_ip_list(char *iplist);
int read_timeo(int sockfd, char *string, int max, int timeo);
int correct_config(void);
int get_ip_range(char *iprange);
int connect_non_blocking(int sockfd, const struct sockaddr *saptr, socklen_t salen, int nsec);
long getip(char *host);
int relay_check(int sockfd, long cur_host);
char *print_checking(long cur_host);
int set_signals(void);
int malloc_mem_needed(void);
int free_mem_needed(void);
int sscan(void);
int mscan(void);
int print_html_results(void);
int print_txt_results(void);
time_t get_time(void);
int thread_start(long cur_host);
void check_webdir(void); 
int open_file(char *filename);
int check_mail(void);
int get_rand(void);
int parse_aconfig(void);
int generate_config(void);
char *get_hostname(const char *addr);
char *read_smtp(int sockfd, int cur_host, int rule, char *check);
int write_smtp(int sockfd, char *command, int cur_host, int rule, char *check);
int send_mail(int sockfd, int rule, int cur_host, char *check);
char *send_mail2(int rule, int cur_host);
int reset_smtp(int sockfd, int cur_host, int rule);
int write_all(int host, int all);
void write_link(char *host, char *ip, char *color);
void write_page(FILE *fd, int host, int rule, char *color);
void print_html_header(FILE *fd);
int check_rule(char *string, char *match);
void print_timed_out(void);
int s_ip_range(char *ip);
int print_m_results(void);
void setup_rules(char *configfile);
char *check_macro(char *string, int cur_host);
char *swap_macro2(char *string, char *macro, char *swap);
char *escape_html_chars(char *string);
char *print_checking2(long cur_host);





/****************************STRUCTURES*************************************/

struct flags {

	int txt_file;
	int m_html_file;
	int ip_list;
	int ip_range;
	int use_conf;
	int scan_range;
	int screen;
	int send_email;
	int got_name;
	int check_mail;
	int aconfig;
	int email_results;
	int gen_config;
	int get_hostname;
	int got_host;
	int print_machine;
	int got_email;
	int verbose_html;

}f;

struct ops {

	FILE *txt_fd;
	FILE *m_html_fd;
	FILE *cur_s_html_fd;

	fd_set *readfds;

	int cur_rule;
	long cur_host;
	int no_rules;
	long no_hostnames;
	int **track;
	int c_timeout;
	int r_timeout;
	int email_timeout;
	int debug;
	int display;
	int verbose;
	int child;
	int goat;

	int cur_childs;
	int *complete;
	int *sockfd;
	int randomn;
	int *smtpopen;
	int passed;
	time_t start_time;

	char cur_hostname[MAXDATA];
	char *config_file;
	char *txt_file;
	char *m_html_file;
	char *cur_s_html_file;
	char *ip_list;
	char *ip_range;
	char *ip_range2;
	char *web_dir;
	char *html_file;
	char *cp;
	char *email_addy;
	char *email_addy2;
	char *domain;
	char *name;
	char *mail_file;
	char *aconfig;
	char *email_results;
	char *gen_config;
	char *machine_file;
	char *email_file;
	char *email;
	char *email_subject;

}o;

struct rulestruct {
	char ***helo;
	char ***mail_from;
	char ***rcpt_to;
}rules;

struct rulestruct2 {
  char **helo;
  char **mail_from;
  char **rcpt_to;
}nrules;


struct smtpreplies {
	char ***helo;
	char ***mail_from;
	char ***rcpt_to;
	char ***data;
	char ***data_end;
	char ***rset;
	char ***banner;
}reply;

struct hostname {
	char **hostname;
	char **rhostname;
}hn;



/*******************************END relay.h***********************************/

