/***************************************************************************
                          relay_check2.c  -  description
                             -------------------
    begin                : Fri Apr 26 2002
    copyright            : (C) 2002 by Spencer Hardy
    email                : diceman@dircon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "relay.h"


char buf3[MAXDATA+2];


int relay_check(int sockfd, long cur_host) {

	int rule = 0;
	char *check;
	char *p;

	check = print_checking2(cur_host);
		
	if(o.debug) {
		//fprintf(stderr, "Starting checks for %s\n", hn.hostname[cur_host]);
	}

  for(rule=0;rule<o.no_rules;rule++) {
		if(o.debug) {
			//fprintf(stderr, "rule == %d and o.no_rules == %d\n",rule, o.no_rules);	
			//fflush(stderr);
		}
		if(!rule) {
			//printf("Entering RULE\n");

			//This is the first connection to the server
			//So read the SMTP banner first.
			//We only need to do this once.

      if((reply.banner[cur_host][rule]=read_smtp(sockfd, cur_host, rule, check)) == NULL)	{
				return(-1);
			}
			if(check_rule(reply.banner[cur_host][rule], "220")) {
				//printf("Recieved non standard banner from %s Not scanning this host\n", hn.hostname[cur_host]);
				strncat(check, "\t<-- Non standard SMTP banner!\n", 500);
				o.track[cur_host][rule] = 1;
				return(-1);
			}
					

			//If banner is ok say HELO to the server.
			//We only need to do this once.
			//Then continue with MAIL FROM, RCPT TO etc.

			if(write_smtp(sockfd, check_macro(nrules.helo[rule], cur_host), cur_host, rule, check)<0) {
				return(-1);
			}
			if((reply.helo[cur_host][rule]=read_smtp(sockfd, cur_host, rule, check)) == NULL) {
				return(-1);
			}
			if(check_rule(reply.helo[cur_host][rule], "250")) {
				strncat(check, " o", 500);
				o.track[cur_host][rule] = 1;
				goto RSET;
			}		
		}

		if(o.debug) {
			printf("Sending *%s*\n", check_macro(nrules.mail_from[rule], cur_host));
		}

		if(write_smtp(sockfd, check_macro(nrules.mail_from[rule], cur_host), cur_host, rule, check)<0) {
			return(-1);
		}

		if((reply.mail_from[cur_host][rule]=read_smtp(sockfd, cur_host, rule, check)) == NULL) {
			return(-1);
		}
		
		if(o.debug) {
			printf("Recieved *%s*\n", reply.mail_from[cur_host][rule]);
		}

		if(check_rule(reply.mail_from[cur_host][rule], "250")) {
			strncat(check, " o", 500);
			o.track[cur_host][rule] = 1;
			goto RSET;
		}
		
			
		if(write_smtp(sockfd, check_macro(nrules.rcpt_to[rule], cur_host), cur_host, rule, check)<0) {
			return(-1);
		}

		if((reply.rcpt_to[cur_host][rule]=read_smtp(sockfd, cur_host, rule, check)) == NULL) {
			return(-1);
		}
		if(check_rule(reply.rcpt_to[cur_host][rule], "250")) {
			strncat(check, " o", 500);
			o.track[cur_host][rule] = 1;
			goto RSET;
		}

		if(f.send_email) {

			//Send an email through the open relay to be sure
			//It relays mail
			
			if(write_smtp(sockfd, "DATA\r\n", cur_host, rule, check)<0) {
				return(-1);
			}

			if(f.verbose_html) {
					if((reply.data[cur_host][rule]=read_smtp(sockfd, cur_host, rule, check))==NULL) {  //354
        	return(-1);
      	}
      	if(check_rule(reply.data[cur_host][rule], "354")) {
        	strncat(check, " !", 500);
        	printf("Recieved a non standard reply to DATA\n");;
        	goto RSET;
      	}
			}
			else {
				if((p=read_smtp(sockfd, cur_host, rule, check))==NULL) {  //354
					return(-1);
				}
				if(check_rule(p, "354")) {
					strncat(check, " !", 500);
					printf("Recieved a non standard reply to DATA\n");;
					goto RSET;
				}
      	free(p);
			}
			if(send_mail(sockfd, rule, cur_host, check)<0) {
				fprintf(stdout, "%s\n", check);
				return(-1);
			}
			if(f.verbose_html) {
				if((reply.data_end[cur_host][rule]=read_smtp(sockfd, cur_host, rule, check))==NULL) {
        	return(-1);
      	}
      	if(check_rule(reply.data_end[cur_host][rule], "250")) {
        	strncat(check, " !", 500);
        	printf("Recieved non standard reply from DATA command\n");
        	goto RSET;
      	}
			}
			else {
				if((p=read_smtp(sockfd, cur_host, rule, check))==NULL) {
					return(-1);
				}
				if(check_rule(p, "250")) {
					strncat(check, " !", 500);
					printf("Recieved non standard reply from DATA command\n");
					goto RSET;
				}
			}

			o.track[cur_host][rule] = 3;
		}
		else {
			o.track[cur_host][rule] = 3;
		}

		strncat(check, " x", 500);
	
		RSET:
		if(reset_smtp(sockfd, cur_host, rule)<0) {
			if(o.verbose) {
				fprintf(stdout, "%s <-- Couldn' reset\n", check);
			}
			return(-1);
		}	
	}
	if(quitsmtp(sockfd, cur_host, rule)<0) {	
		if(o.verbose) {
			fprintf(stdout, "%s <-- Couldn't quit\n", check);
		}
		return(-1);
	}
	if(o.track[cur_host][o.no_rules+1] != 3 && o.track[cur_host][o.no_rules+1] != 2 && o.track[cur_host][o.no_rules+1] != 1 && !o.verbose) {
		fprintf(stdout, "%s\n", check);
	}
	else if(o.verbose) {
		fprintf(stdout, "%s\n", check);
  }

	return(0);
}
						



