/***************************************************************************
                          relay_funcs.c  -  description
                             -------------------
    begin                : Fri Apr 26 2002
    copyright            : (C) 2002 by Spencer Hardy
    email                : diceman@dircon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "relay.h"

extern char check[MAXDATA+1];

int write_smtp(int sockfd, char *command, int cur_host, int rule, char *check) {

	int size = strlen(command);

	if(send(sockfd, command, size, MSG_NOSIGNAL) == -1) {
		if(errno == MSG_NOSIGNAL) {
    	o.track[cur_host][o.no_rules+1] = 1;
			strncat(check, "\t<-- Error Sending Command!", 500);
			fprintf(stdout, "%s\n", check);
			quitsmtp(sockfd, cur_host, rule);
      return(-1);
		}
		else {
			strncat(check, "\t<-- Error Sending Command!", 500);
			fprintf(stdout, "%s\n", check);
			perror("send");
			return(-1);
		}
	}
	return(0);
}

char *read_smtp(int sockfd, int cur_host, int rule, char *check) {


	char buf[MAXDATA+1];
	char *string;
	int size = 0;
	int ret;
	
	if((ret=read_timeo(sockfd, buf, MAXDATA, o.r_timeout)) == -1) {
		o.track[cur_host][o.no_rules+1] = 2;
		if(o.verbose) {
			fprintf(stdout, "%s\t<-- Timed Out!\n", check);
		}
		close(sockfd);
		return(NULL);
	}
	if(ret==0) {
		o.track[cur_host][o.no_rules+1] = 3;
		if(o.verbose) {
			fprintf(stdout, "%s\t<-- Remote host closed connection!\n", check);
		}
		close(sockfd);
		return(NULL);
	}
			
	size = strlen(buf);
	string=s_malloc((size+1) * sizeof(char));
	strncpy(string, buf, size);
	string[size]='\0';

	return(string);

}

int check_rule(char *string, char *match) {

	if(strncmp(string, match, strlen(match))) {
		return(1);
	}

	return(0);

}
	

int send_mail(int sockfd, int rule, int cur_host, char *check) {

	char *email = "This message is a test probe, to ensure that your mail server is secured"
								" against third-party mail relay. This is NOT an attempt to hack or crack "
								"your system, but just to ensure the system(s) are secured against this common "
								"vulnerability.\r\n\r\nA well-configured mail server should NOT relay third-party email. "
								"Otherwise, the server is subject to attack and hijack by Internet vandals and spammers. "
								"For information on how to secure a mail server against third-party relaying, visit http://mail-abuse.org/tsi/\r\n\r\n";
	char *subject = "Subject: Test for susceptibility to relaying third-party mail.\r\n";
  char *email2;

	if(!f.got_email) {
		int email_size = strlen(email) + strlen(subject) + strlen("SmtpRCKey");
		email_size+=122;
		email2=s_malloc(email_size * sizeof(char));
		snprintf(email2, email_size, "%s\r\n%s:SmtpRCKey:%d:%s:%d:\r\n\r\n.\r\n", subject, email, o.randomn, hn.hostname[cur_host], rule);
	}
	else {
		int email_size = strlen(o.email) + strlen(o.email_subject) + strlen("SmtpRCKey");
    email_size+=122;
    email2=s_malloc(email_size * sizeof(char));
    snprintf(email2, email_size, "Subject: %s\r\n%s:SmtpRCKey:%d:%s:%d:\r\n\r\n.\r\n", o.email_subject, o.email, o.randomn, hn.hostname[cur_host], rule);
  }

	if(send(sockfd, email2, strlen(email2), MSG_NOSIGNAL) == -1) {
		if(errno == MSG_NOSIGNAL) {
    	o.track[cur_host][o.no_rules+1] = 1;
			strncat(check, "\t<-- Error Sending Command!", 500);
      return(-1);
		}
		else {
			strncat(check, "\t<-- Error Sending Command!", 500);
			perror("send");
		}
	}
	return(0);

}

char *send_mail2(int rule, int cur_host) {

  char *email = "This message is a test probe, to ensure that your mail server is secured"
                " against third-party mail relay. This is NOT an attempt to hack or crack "
                "your system, but just to ensure the system(s) are secured against this common "
                "vulnerability.\r\n\r\nA well-configured mail server should NOT relay third-party email. "
                "Otherwise, the server is subject to attack and hijack by Internet vandals and spammers. "
                "For information on how to secure a mail server against third-party relaying, visit http://mail-abuse.org/tsi/\r\n\r\n";
  char *subject = "Subject: Test for susceptibility to relaying third-party mail.\r\n";
  char *email2;

  if(!f.got_email) {
    int email_size = strlen(email) + strlen(subject) + strlen("SmtpRCKey");
    email_size+=122;
    email2=s_malloc(email_size * sizeof(char));
    snprintf(email2, email_size, "%s\r\n%s:SmtpRCKey:%d:%s:%d:\r\n\r\n.\r\n", subject, email, o.randomn, hn.hostname[cur_host], rule);
  }
  else {
    int email_size = strlen(o.email) + strlen(o.email_subject) + strlen("SmtpRCKey");
    email_size+=122;
    email2=s_malloc(email_size * sizeof(char));
    snprintf(email2, email_size, "Subject: %s\r\n%s:SmtpRCKey:%d:%s:%d:\r\n\r\n.\r\n", o.email_subject, o.email, o.randomn, hn.hostname[cur_host], rule);
  }
	
	return(email2);
}

int quitsmtp(int sockfd, int cur_host, int rule) {

	char *buf;
	
	if(write_smtp(sockfd, "QUIT\r\n", cur_host, rule, NULL)<0) {
		return(-1);
	}

	if((buf=read_smtp(sockfd, cur_host, rule, "NULL"))==NULL) {
		close(sockfd);
		return(-1);
	}

	close(sockfd);
	
	return(0);

}

int reset_smtp(int sockfd, int cur_host, int rule) {


	char *buf;

	if(write_smtp(sockfd, "RSET\r\n", cur_host, rule, NULL)<0) {
		return(-1);
	}

	if(f.verbose_html) {
		if((reply.rset[cur_host][rule]=read_smtp(sockfd, cur_host, rule, "NULL"))==NULL) {
			return(-1);
		}
		if(check_rule(reply.rset[cur_host][rule], "250")) {
			printf("Recieved a non standard reply from RSET not scanning this server\n");
		}
	}
	else {
		if((buf=read_smtp(sockfd, cur_host, rule, "NULL"))==NULL) {
      return(-1);
    }
    if(check_rule(buf, "250")) {
      printf("Recieved a non standard reply from RSET not scanning this server\n");
    }
  }

	return(0);

}

char *print_checking(long cur_host) {

	int hnsize = 0;
	char check[MAXDATA+1];
	char *check2;
	int size;

	if(f.get_hostname && strncmp(hn.hostname[cur_host], hn.rhostname[cur_host], strlen(hn.hostname[cur_host]))) {
		if(o.child) {
			snprintf(check, MAXDATA, "Checking %s\t\t\t", get_hostname(hn.hostname[cur_host]));
		}
		else {
			printf("Checking %s\t\t\t", get_hostname(hn.hostname[cur_host]));
   	 	fflush(stdout);
	  }
	}
	else {
	
		hnsize = strlen(hn.hostname[cur_host]);

		if(hnsize<8) {
			if(o.child)
				snprintf(check, MAXDATA, "Checking %s\t\t\t\t", hn.hostname[cur_host]);
		 	 else {
				printf("Checking %s\t\t\t\t", hn.hostname[cur_host]);
				fflush(stdout);
			}
		}
		else if(hnsize<15) {
			if(o.child)
				snprintf(check, MAXDATA, "Checking %s\t\t\t\t", hn.hostname[cur_host]);
			else {
				printf("Checking %s\t\t\t\t", hn.hostname[cur_host]);
				fflush(stdout);
			}
		}
		else if(hnsize<23) {
			if(o.child)
				snprintf(check, MAXDATA, "Checking %s\t\t\t", hn.hostname[cur_host]);
		 	 else {
				printf("Checking %s\t\t\t", hn.hostname[cur_host]);
				fflush(stdout);
			}
		}
		else if(hnsize<31)  {
			if(o.child)
				snprintf(check, MAXDATA, "Checking %s\t", hn.hostname[cur_host]);
			else {
			  printf("Checking %s\t", hn.hostname[cur_host]);
				fflush(stdout);
			}
		}
		else {	
			if(o.child)
				snprintf(check, MAXDATA, "Checking %s ", hn.hostname[cur_host]);
			else {
				printf("Checking %s ", hn.hostname[cur_host]);
				fflush(stdout);
			}
		}
	}
	size =  501;
	check2=s_malloc(size);
	memset(check2, 0x0, size+1);
	strncpy(check2, check, size);
	check2[strlen(check)] = '\0';
	return(check2);
}


char *print_checking2(long cur_host) {

  int hnsize = 0;
	int padsize = 60;
  char check[padsize+1];
  char *check2;

  if(f.get_hostname && strncmp(hn.hostname[cur_host], hn.rhostname[cur_host], strlen(hn.hostname[cur_host]))) {
    if(o.child) {
      snprintf(check, padsize, "Checking %s%200c ", get_hostname(hn.hostname[cur_host]), ' ');
    }
    else {
      printf("Checking %s%70c ", get_hostname(hn.hostname[cur_host]), ' ');
      fflush(stdout);
    }
  }
  else {
    hnsize = strlen(hn.hostname[cur_host]);
    if(o.child)
      snprintf(check, padsize, "Checking %s%200c ", hn.hostname[cur_host], ' ');
    else {
      printf("Checking %s%70c ", hn.hostname[cur_host], ' ');
      fflush(stdout);
    }
  }
  check2=s_malloc((padsize+500) * sizeof(char));
  memset(check2, 0x0, padsize+500);
  strncpy(check2, check, padsize);
  check2[strlen(check)] = '\0';
  return(check2);
}


